/*

  Copyright (C) 2000, 2001 Silicon Graphics, Inc.  All Rights Reserved.

  This program is free software; you can redistribute it and/or modify it
  under the terms of version 2 of the GNU General Public License as
  published by the Free Software Foundation.

  This program is distributed in the hope that it would be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

  Further, this software is distributed without any warranty that it is
  free of the rightful claim of any third person regarding infringement 
  or the like.  Any license provided herein, whether implied or 
  otherwise, applies only to this software file.  Patent licenses, if 
  any, provided herein do not apply to combinations of this program with 
  other software, or any other product whatsoever.  

  You should have received a copy of the GNU General Public License along
  with this program; if not, write the Free Software Foundation, Inc., 59
  Temple Place - Suite 330, Boston MA 02111-1307, USA.

  Contact information:  Silicon Graphics, Inc., 1600 Amphitheatre Pky,
  Mountain View, CA 94043, or:

  http://www.sgi.com

  For further information regarding this notice, see:

  http://oss.sgi.com/projects/GenInfo/NoticeExplan

*/


#ifndef dra_demangle_INCLUDED
#define dra_demangle_INCLUDED

/* ====================================================================
 * ====================================================================
 *
 * Module: dra_demangle.h
 *
 * Revision history:
 *  20-Aug-96: Original Version, nenad
 *
 * Description: Interface for demangling utility functions
 *              needed in emitting user-understandable error
 *              messages by the (dsm_)prelinker, linker, and
 *              run-time error checking code generated by LNO.
 *
 * ====================================================================
 * ==================================================================== 
 */

#ifdef __cplusplus
extern "C" {
#endif

/* 
 * Extract only the function name
 */
extern char* DRA_Demangle_Func (const char* mangled_name);

/* 
 * Extract and demangle the argument list
 */
extern char* DRA_Demangle_Arglist (const char* mangled_name,
                                   const char dim_order);

/*
 * Extract and demangle both the function name and the argument list
 */
extern char* DRA_Demangle (const char* mangled_name,
                           const char dim_order);

#ifdef __cplusplus
}
#endif


/*
 * Acceptable dimension order specifiers 
 */

#define DRA_DIMS_ROWWISE    'C'  /* C as in C, C++  */
#define DRA_DIMS_COLUMNWISE 'F'  /* F as in Fortran */
#define DRA_DIMS_UNKNOWN   '\0'  /* Uninitialized   */


#endif /* dra_demangle_INCLUDED */
