/* THIS FILE IS AUTOMATICALLY GENERATED BY table */

#include <stddef.h>
#include "options.h"
#include "option_seen.h"
#include "option_names.h"
#include "opt_actions.h"
#include "errors.h"

/* replace individual options with combo */
static void
replace_with_combo (int combo_index)
{
	int flag;
	int count = 1;
	FOREACH_OPTION_IN_COMBO(flag,combo_index) {
		if (count == 1) {
			replace_option_seen(flag, combo_index);
		} else {
			set_option_unseen(flag);
		}
		count++;
	}
}

static void
report_combo_errors (void)
{
	if (option_was_seen(O_KPIC_non_shared)) {
		warning("-KPIC -non_shared combination not allowed, replaced with -non_shared");
	}
	if (option_was_seen(O_abi_non_shared)) {
		warning("-abi -non_shared combination not allowed, replaced with -abi");
	}
}

extern boolean
is_replacement_combo (int combo_index)
{
	switch (combo_index) {
	case O_KPIC_non_shared:
	case O_abi_non_shared:
		return TRUE;
	default:
		return FALSE;
	}
}

extern void
check_for_combos (void)
{
	if (option_was_seen(O_non_shared) && option_was_seen(O_KPIC)) {
		replace_with_combo(O_KPIC_non_shared);
		untoggle(&shared,NON_SHARED);
	}
	if (option_was_seen(O_non_shared) && option_was_seen(O_abi)) {
		replace_with_combo(O_abi_non_shared);
		untoggle(&shared,NON_SHARED);
	}
	report_combo_errors();
}

