#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 58 "c-parse.y"
/* $Id: c-parse.y,v 1.34 2012/01/18 20:54:25 phargrov Exp $ */

#include "config.h"
#include "system.h"
#include <setjmp.h>

#include "tree.h"
#include "input.h"
#include "c-lex.h"
#include "c-tree.h"
#include "flags.h"
#include "output.h"
#include "toplev.h"
#include "ggc.h"

#ifdef MULTIBYTE_CHARS
#include <locale.h>
#endif

#include <upc-act.h>


/* Since parsers are distinct for each language, put the language string
   definition here.  */
const char * const language_string = "GNU UPC";

 extern void WFE_Pop_Pragma();  /*from wfe_dst.cxx*/
 extern void WFE_Push_Pragma();  /*from wfe_dst.cxx*/
 extern void WFE_Start_Inner_Scope();
 extern void WFE_Finish_Inner_Scope();
 
 extern int defining_type; 

/* Like YYERROR but do call yyerror.  */
#define YYERROR1 { yyerror ("syntax error"); YYERROR; }

/* Cause the `yydebug' variable to be defined.  */
/* #define YYDEBUG 1  -- Set via HOSTDEFS in Makefile.gbase, and then only for DEBUG builds */
#line 100 "c-parse.y"
typedef union {long itype; tree ttype; enum tree_code code;
	const char *filename; int lineno; int ends_in_label; } YYSTYPE;
#line 234 "c-parse.y"
/* Number of statements (loosely speaking) and compound statements 
   seen so far.  */
static int stmt_count;
static int compstmt_count;
  
/* Input file and line number of the end of the body of last simple_if;
   used by the stmt-rule immediately after simple_if returns.  */
static char *if_stmt_file;
static int if_stmt_line;

/* List of types and structure classes of the current declaration.  */
/*static*/ tree current_declspecs = NULL_TREE;
static tree prefix_attributes = NULL_TREE;

/* Stack of saved values of current_declspecs and prefix_attributes.  */
static tree declspec_stack;

/* 1 if we explained undeclared var errors.  */
/*static*/ int undeclared_variable_notice;

/* A phony value of for_init_stmt identifying a for loop w/ c99 declaration.
   Anything that can't be a valid statement is suitable.  */
#define c99_for_node integer_type_node


/* Tell yyparse how to print a token's value, if yydebug is set.  */

#define YYPRINT(FILE,YYCHAR,YYLVAL) yyprint(FILE,YYCHAR,YYLVAL)
extern void yyprint			PARAMS ((FILE *, int, YYSTYPE));

/* Add GC roots for variables local to this file.  */
void
c_parse_init ()
{
  ggc_add_tree_root (&declspec_stack, 1);
  ggc_add_tree_root (&current_declspecs, 1);
  ggc_add_tree_root (&prefix_attributes, 1);
}
#line 98 "c-parse.c"
#define YYERRCODE 256
#define IDENTIFIER 257
#define TYPENAME 258
#define SCSPEC 259
#define TYPESPEC 260
#define TYPE_QUAL 261
#define TYPE_QUAL_S 262
#define CONSTANT 263
#define STRING 264
#define ELLIPSIS 265
#define SIZEOF 266
#define ENUM 267
#define STRUCT 268
#define UNION 269
#define IF 270
#define ELSE 271
#define WHILE 272
#define DO 273
#define FOR 274
#define SWITCH 275
#define CASE 276
#define DEFAULT 277
#define BREAK 278
#define CONTINUE 279
#define RETURN 280
#define GOTO 281
#define ASM_KEYWORD 282
#define TYPEOF 283
#define ALIGNOF 284
#define ATTRIBUTE 285
#define EXTENSION 286
#define LABEL 287
#define REALPART 288
#define IMAGPART 289
#define ASSIGN 290
#define OROR 291
#define ANDAND 292
#define EQCOMPARE 293
#define ARITHCOMPARE 294
#define LSHIFT 295
#define RSHIFT 296
#define UNARY 297
#define PLUSPLUS 298
#define MINUSMINUS 299
#define HYPERUNARY 300
#define POINTSAT 301
#define INTERFACE 302
#define IMPLEMENTATION 303
#define END 304
#define SELECTOR 305
#define DEFS 306
#define ENCODE 307
#define CLASSNAME 308
#define PUBLIC 309
#define PRIVATE 310
#define PROTECTED 311
#define PROTOCOL 312
#define OBJECTNAME 313
#define CLASS 314
#define ALIAS 315
#define OBJC_STRING 316
#define FORALL 317
#define UPC_BLOCKSIZEOF 318
#define UPC_LOCALSIZEOF 319
#define UPC_ELEMSIZEOF 320
#define UPC_BARRIER 321
#define UPC_NOTIFY 322
#define UPC_WAIT 323
#define END_OF_LINE 324
#define UPC_FENCE 325
#define BUPC_ASSERT_TYPE 326
const short yylhs[] = {                                        -1,
    0,    0,   85,   83,   86,   83,   84,   84,   84,   84,
   88,   88,   88,   88,   88,   88,   88,   88,   91,   93,
   87,   87,   94,   95,   87,   87,   96,   97,   87,   87,
    2,    2,    1,    1,    1,    1,    1,    1,    1,    3,
    5,    5,    4,    4,    8,    8,    8,    8,    8,    8,
    8,    8,    8,    8,    8,    8,    8,    8,    8,    8,
    8,   79,   80,   81,   82,   98,   99,    7,    7,  101,
    7,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,  102,    6,  103,    6,  104,  105,
    6,  106,    6,    6,    6,    9,    9,    9,    9,    9,
  107,    9,    9,    9,    9,    9,    9,    9,    9,    9,
    9,    9,   10,   10,   90,   90,   90,  109,  108,  108,
  108,  108,  110,  110,  110,  110,   70,  112,  113,  113,
  113,  113,  113,  113,  113,   11,   11,   12,   12,   12,
   12,   18,   18,   19,   19,   19,   15,   15,   15,   15,
   20,   20,   20,   20,   58,   58,   58,   13,   13,   78,
   14,   14,   16,   16,   16,   16,   16,   17,   17,   17,
   17,   17,   23,   23,   24,   24,   28,   28,  116,   25,
   25,  117,   26,   26,   33,   33,   34,   34,   35,   36,
   36,   37,   37,   37,   37,   37,   38,   38,   38,   38,
   38,   27,  118,   27,   27,  100,  100,  119,  119,  121,
  121,  125,  121,  121,  126,  123,  123,  123,  122,  122,
  124,  124,  124,  127,  128,  114,  129,  130,  115,   40,
   40,   42,   42,   42,   42,   42,   42,   42,   43,   43,
   43,   43,   43,   43,   43,   41,   41,   41,   41,   41,
   41,   41,   41,   52,   52,   53,   53,   54,   54,  131,
   44,   44,   44,  132,   44,   44,   44,  133,   44,  135,
   44,   44,  120,  120,  134,  134,   45,   45,   46,   46,
   46,   47,   47,   47,   47,   47,   47,   48,   48,   49,
   49,   49,   50,   50,   50,   51,   51,   55,   55,   56,
   56,   21,   21,   59,   59,   57,   57,   57,   57,   57,
   57,   57,   57,   57,   57,  136,   73,   73,   73,  111,
  137,  138,  138,  139,  139,  140,   92,   92,  141,   39,
   39,   39,  142,  142,  143,  146,  145,   75,   76,  144,
  144,   72,   74,   74,   74,  147,  147,  147,  150,  147,
  147,  147,  151,  152,  147,  147,  147,  153,  154,  155,
  147,  156,  157,  158,  159,  147,  160,  147,  147,  147,
  147,  147,  147,  147,  147,  147,  147,  147,  147,  147,
  147,  147,  147,  147,  147,  147,  161,   71,   71,   77,
   77,  149,  163,  162,  148,  148,  148,  148,   22,   22,
   60,   60,   60,   29,   29,   30,   30,   31,   32,   32,
  164,   64,   65,  165,   65,   65,   66,   66,   66,   66,
   61,   61,   62,   62,   62,   62,   62,  166,   67,   68,
   68,   63,   63,   69,   69,   89,
};
const short yylen[] = {                                         2,
    0,    1,    0,    2,    0,    3,    1,    1,    5,    2,
    3,    4,    4,    2,    2,    2,    2,    1,    0,    0,
    7,    4,    0,    0,    7,    4,    0,    0,    6,    3,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    0,    1,    1,    3,    1,    2,    2,    2,    2,    2,
    4,    2,    4,    2,    4,    2,    4,    2,    4,    2,
    2,    1,    1,    1,    1,    1,    1,    1,    4,    0,
    7,    1,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    0,    4,    0,    4,    0,    0,
    7,    0,    5,    3,    3,    1,    1,    1,    3,    3,
    0,    4,    6,    6,    6,    6,    4,    4,    3,    3,
    2,    2,    1,    2,    0,    1,    2,    3,    1,    1,
    2,    2,    4,    4,    2,    2,    0,    0,    4,    4,
    3,    3,    2,    2,    2,    2,    3,    0,    2,    2,
    2,    2,    3,    0,    2,    2,    1,    1,    2,    2,
    1,    1,    2,    2,    1,    1,    2,    2,    3,    3,
    0,    2,    1,    1,    1,    4,    4,    1,    1,    1,
    2,    1,    1,    3,    1,    3,    0,    4,    0,    6,
    3,    0,    6,    3,    0,    1,    1,    2,    6,    1,
    3,    0,    1,    4,    6,    4,    1,    1,    1,    1,
    1,    1,    0,    4,    1,    0,    2,    1,    3,    3,
    2,    0,    4,    1,    0,    4,    1,    1,    1,    2,
    2,    5,    3,    0,    0,    5,    0,    0,    5,    1,
    1,    3,    3,    4,    3,    3,    3,    1,    3,    4,
    4,    3,    3,    3,    1,    3,    3,    3,    4,    4,
    3,    3,    1,    1,    2,    1,    2,    1,    2,    0,
    7,    5,    2,    0,    7,    5,    2,    0,    8,    0,
    7,    2,    0,    1,    0,    1,    1,    2,    0,    3,
    2,    3,    1,    3,    1,    1,    2,    1,    3,    4,
    6,    5,    1,    3,    1,    1,    3,    2,    2,    0,
    1,    1,    2,    0,    2,    3,    3,    2,    3,    4,
    3,    2,    3,    2,    3,    1,    1,    2,    2,    2,
    0,    0,    1,    1,    2,    3,    1,    2,    1,    2,
    5,    5,    2,    2,    4,    0,    4,    0,    0,    3,
    4,    3,    1,    1,    1,    1,    1,    2,    0,    4,
    1,    3,    0,    0,    7,    5,    2,    0,    0,    0,
   11,    0,    0,    0,    0,   14,    0,    6,    2,    2,
    2,    3,    2,    2,    3,    2,    3,    2,    3,    6,
    8,   10,   12,    3,    4,    1,    0,    2,    2,    1,
    1,    1,    0,    6,    3,    5,    2,    3,    0,    1,
    0,    1,    1,    0,    1,    1,    3,    4,    1,    3,
    0,    2,    2,    0,    4,    2,    0,    1,    1,    3,
    1,    3,    4,    4,    4,    4,    4,    0,    2,    1,
    2,    1,    3,    1,    3,    1,
};
const short yydefred[] = {                                      0,
    0,    0,    0,    0,    0,  165,  152,  163,  155,    0,
    0,    0,    0,    0,    0,    0,  436,   18,    0,    0,
  138,    0,    0,  187,  164,    0,    0,    0,  151,    0,
    4,    7,    8,    0,    6,   16,   17,    0,  157,    0,
    0,    0,    0,    0,    0,   15,    0,   14,  138,    0,
    0,    0,    0,  154,  153,  188,   31,   32,  279,    0,
  279,    0,  270,    0,  253,  304,    0,    0,  175,    0,
    0,   10,   96,   97,  113,   66,   67,    0,    0,    0,
   33,   35,   34,    0,   36,   37,    0,   62,   63,   64,
   65,   38,   39,    0,  402,    0,    0,   72,   68,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  161,    0,    0,  302,    0,  238,  304,
    0,    0,  173,    0,    0,    0,    0,    0,    0,    0,
  140,  168,  169,    0,  139,    0,  172,    0,    0,  260,
    0,  264,    0,  268,    0,    0,   11,    0,    0,   30,
    0,  428,    0,    0,    0,   60,   61,   49,   46,    0,
    0,    0,    0,   48,    0,    0,    0,    0,   87,   85,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  111,  112,    0,    0,    0,    0,  114,  160,
    0,   52,    0,   54,    0,   56,    0,   47,    0,   50,
    0,   58,    0,  166,  304,    0,    0,    0,  298,    0,
    0,  161,  299,  303,  167,  198,  199,  200,  201,  197,
    0,  190,    0,    0,    0,   13,    0,    0,   22,    0,
    0,  428,    0,   12,   26,    0,  171,    0,  286,  281,
    0,    0,    0,    0,  279,    0,  279,  295,    0,    0,
  293,    0,    0,  305,  247,  176,    0,    0,    0,  246,
    0,    0,  251,    0,    0,    0,    0,  339,   28,    0,
    0,  120,  100,   99,    0,  329,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   75,   76,   77,  110,  109,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    9,    0,    0,  312,    0,  314,    0,    0,  411,    0,
  162,    0,    0,    0,    0,    0,  232,  174,    0,    0,
   20,  233,  235,    0,   24,  262,  338,  338,  280,  287,
    0,  266,    0,    0,    0,    0,    0,    0,    0,  432,
  418,  127,    0,    0,  421,    0,  430,    0,  429,  249,
  250,  182,  320,    0,    0,  117,  121,  122,   70,   69,
  102,  330,    0,    0,    0,    0,    0,  107,  108,   53,
   55,   57,    0,    0,   51,   59,    0,  306,  412,  313,
    0,  309,  311,    0,  189,  191,    0,    0,  179,    0,
  234,    0,    0,  288,  339,    0,    0,    0,    0,  294,
    0,    0,  178,  416,    0,    0,  414,    0,  431,    0,
  413,    0,  144,    0,    0,  118,    0,  327,   29,    0,
    0,    0,    0,  324,   90,    0,    0,    0,    0,    0,
  310,  194,    0,  196,    0,   21,   25,  338,    0,  261,
  265,  271,    0,  245,  304,    0,    0,    0,    0,    0,
  304,    0,    0,    0,    0,  420,  422,  433,  205,  203,
    0,  183,    0,  125,    0,  126,  144,    0,  328,  218,
    0,    0,    0,  215,    0,    0,    0,    0,  208,    0,
  214,    0,  434,    0,    0,  317,    0,  339,    0,  325,
    0,  106,  105,  104,  103,    0,  180,  289,    0,    0,
  269,    0,    0,  424,  428,    0,  423,  425,    0,    0,
  426,  427,  415,    0,  146,  145,    0,    0,    0,    0,
  221,    0,    0,  212,   71,    0,  207,    0,  220,  211,
  326,    0,  331,  318,  319,    0,  332,    0,  195,    0,
    0,  290,    0,    0,  239,    0,  242,    0,    0,  123,
  124,    0,  223,    0,    0,  209,  210,  435,    0,    0,
  353,  336,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  386,    0,    0,    0,
    0,  346,  342,    0,  345,    0,    0,    0,  343,  344,
  347,  392,  292,    0,  240,  241,  204,    0,  216,  213,
    0,    0,  338,    0,    0,    0,  397,  369,  370,  371,
    0,    0,    0,  400,    0,    0,  378,    0,  373,    0,
  376,    0,  374,    0,  348,  133,    0,  134,    0,  135,
    0,  334,  339,  333,  357,    0,  291,  222,    0,    0,
    0,    0,    0,  358,  338,    0,    0,  395,  372,    0,
  384,    0,  362,  379,  375,  377,  398,    0,    0,  131,
    0,    0,  132,  352,  338,    0,    0,  335,    0,  337,
  393,  388,    0,  389,  367,    0,  385,    0,    0,  129,
    0,  130,    0,  350,  340,  338,    0,  354,  338,    0,
  338,  396,    0,    0,    0,  225,  228,  341,  356,  338,
  394,  359,  368,    0,    0,    0,  406,  380,  363,    0,
    0,  355,    0,    0,    0,    0,    0,    0,  226,  229,
    0,    0,    0,  381,  407,    0,  360,  408,    0,    0,
  364,  338,    0,    0,  382,    0,  361,    0,    0,  391,
  390,    0,  383,    0,  365,  338,  366,
};
const short yydgoto[] = {                                       1,
   94,  485,   95,   96,  301,   97,   98,   99,  100,  101,
  352,   53,  113,  211,  353,  114,  135,  424,  473,   22,
  115,  625,  122,   68,  123,   69,  472,  154,  715,  716,
  717,  744,  265,  266,   24,  221,  222,  223,  428,  257,
  126,  127,  459,   25,  138,  139,  243,  403,  404,  250,
  251,   26,   27,   28,  116,  209,  210,   29,  145,  653,
  354,  355,  356,  314,  357,  358,  260,  359,  494,   30,
  654,  496,  497,  593,  643,  364,  752,   39,  103,  104,
  105,  106,    2,   31,    3,    4,   32,   33,  107,  269,
  231,  429,  400,  236,  402,  155,  365,  108,  109,  487,
  430,  285,  284,  282,  501,  283,  163,  270,  271,  426,
  272,  149,  595,  670,  673,  445,  422,  524,  488,  537,
  489,  490,  491,  492,  565,  533,  691,  720,  693,  721,
  245,  247,  252,  346,  143,  499,  373,  432,  433,  434,
  278,  596,  597,  644,  598,  613,  599,  600,  601,  675,
  612,  710,  683,  723,  742,  689,  728,  746,  756,  701,
  655,  602,  699,  315,  465,  261,
};
const short yysindex[] = {                                      0,
    0,    0, 5097, 5097,   63,    0,    0,    0,    0,  -22,
 -193, -193, -193,   87,  150,  177,    0,    0,   44, 1310,
    0,  422, -193,    0,    0,  -27,  116,  127,    0,   84,
    0,    0,    0, 5097,    0,    0,    0, 3317,    0, -193,
 -193, -193, 3382, 2114,  181,    0,  243,    0,    0,  422,
 -193,   84, 1052,    0,    0,    0,    0,    0,    0,   33,
    0,  104,    0,  131,    0,    0,   84,  467,    0, -193,
   16,    0,    0,    0,    0,    0,    0, 3382, 3382, -195,
    0,    0,    0, 3382,    0,    0, 2044,    0,    0,    0,
    0,    0,    0, 3382,    0,   54, 4358,    0,    0,   37,
 -127,  230, 3421, 3471, 3546,  313, 3382, 3585, 3650, 3382,
  392,  431,   47,    0,  572,  451,    0, 1065,    0,    0,
  243,  509,    0, -193,   32,  316,  323, 1052,  714,  101,
    0,    0,    0,  -22,    0, -193,    0,  145, 1178,    0,
  368,    0,  223,    0,  118,  660,    0,  243,   84,    0,
  465,    0, 2420, -193,  258,    0,    0,    0,    0,  483,
  492,  499,  436,    0, 3382, 3382, 3382,    0,    0,    0,
 3382, 3382, 3382, 3382, 3382, 3382, 3382, 3382, 3382, 3382,
 3382, 3382,    0,    0, -195, -195, 3382, 3382,    0,    0,
 2044,    0, 2044,    0, 2044,    0, 2158,    0, 2044,    0,
 2044,    0,  504,    0,    0,   47, 2478, -193,    0,  327,
  839,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  405,    0,  543,  485,  695,    0,  243,  243,    0, -193,
  258,    0, 2543,    0,    0,  258,    0, -193,    0,    0,
    0, 1916,  512, 1752,    0, -193,    0,    0,  530,  573,
    0,  223,  316,    0,    0,    0,  347,  316,  398,    0,
 2357, 2608,    0,  616,  655, -193,  664,    0,    0,  460,
  258,    0,    0,    0, 2652,    0,  727,  674, 4358, 4358,
 4358, 3382,  722, 3382, 3382,  384, 1010,  171,  129,   31,
  942,  942,  986,  986,    0,    0,    0,    0,    0,   54,
  770,  720,  774,  776,  787, 2710,  792,  806,  813,  815,
    0,  143,  769,    0, 2819,    0,  771,   47,    0, 2775,
    0,  839,  825, 1065, 3735,  323,    0,    0,  323,  809,
    0,    0,    0,  779,    0,    0,    0,    0,    0,    0,
  751,    0,  753, 3382, -195,  765,  573,   20,  857,    0,
    0,    0, 3284,  743,    0,  575,    0,  859,    0,    0,
    0,    0,    0, 1651,  -77,    0,    0,    0,    0,    0,
    0,    0,  615,  853, 3382,  252,  854,    0,    0,    0,
    0,    0, 2158, 2158,    0,    0,  327,    0,    0,    0,
  327,    0,    0,  819,    0,    0,  611,  877,    0,  -77,
    0,  -77,  875,    0,    0,  875, -193, -193, 4358,    0,
 -193,  801,    0,    0,  369,   39,    0, 2959,    0,  671,
    0, 2243,    0,  874, 1322,    0,  436,    0,    0,  595,
 -195,  678,  615,    0,    0,  677,  894,  904,  911,  922,
    0,    0, 3382,    0, 2243,    0,    0,    0,  303,    0,
    0,    0, -193,    0,    0,   39, -193,   -6,   18, -193,
    0, -193,   -6, -193, 2819,    0,    0,    0,    0,    0,
 4358,    0,  873,    0,  243,    0,    0,   84,    0,    0,
    0, -195, 3382,    0,  896, 4358,  850,  938,    0,  603,
    0, 2346,    0,  747,  869,    0,  258,    0,  872,    0,
 3382,    0,    0,    0,    0,  663,    0,    0, 3382,    1,
    0,   93,  369,    0,    0, 2842,    0,    0,   48,   39,
    0,    0,    0,  595,    0,    0,  772,  873,  823,   25,
    0, 4076,  595,    0,    0,  595,    0, 2346,    0,    0,
    0, -195,    0,    0,    0, 1508,    0,  677,    0, 4215,
 3382,    0,  362,  362,    0, 2914,    0,  895,  876,    0,
    0, 3382,    0,  884, 2346,    0,    0,    0,    0,  962,
    0,    0,  971,  973, 3382,  958,  960,  961, 2972,   62,
  761,  985, 3011, 3079, 3150,  970,    0,  976,  977,  979,
 1578,    0,    0, 1609,    0,  764,  783,  161,    0,    0,
    0,    0,    0, 4215,    0,    0,    0, 4226,    0,    0,
 3382, 1000,    0, 3317, 3382, 4117,    0,    0,    0,    0,
  984, 3382,  987,    0, 1004, 3317,    0,  990,    0,  991,
    0,  992,    0, -193,    0,    0,  243,    0,   84,    0,
  798,    0,    0,    0,    0, 3382,    0,    0, 1017, 3382,
  803,   14, 1030,    0,    0, 1050, 3382,    0,    0, 1035,
    0, 3382,    0,    0,    0,    0,    0,  830,  347,    0,
  844,   25,    0,    0,    0, 1776, 1063,    0, 1068,    0,
    0,    0, 3317,    0,    0, 4336,    0,  389, 3317,    0,
  258,    0,  258,    0,    0,    0, 1054,    0,    0, 1057,
    0,    0,  847, 1059, 1060,    0,    0,    0,    0,    0,
    0,    0,    0, 1080,  508, 1084,    0,    0,    0,  436,
  436,    0, 3317, 3382,  847, 1077,  847, 3317,    0,    0,
 1096, 1097,  531,    0,    0, 1085,    0,    0,  398, 1086,
    0,    0, -127,  700,    0, 3208,    0, 1087,  398,    0,
    0, 1098,    0, -127,    0,    0,    0,
};
const short yyrindex[] = {                                    470,
    0,  536,  138,  138,    0,    0,    0,    0,    0, 4598,
  139,  194,  198,    0,    0,    0,    0,    0,  708,  138,
    0,  723, 4783,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  138,    0,    0,    0,  779,    0,  205,
  229,  367,    0,    0,    0,    0,    0,    0,    0, 4763,
 4995,    0, 1664,    0,    0,    0,    0,    0,    0, 4647,
    0, 4660,    0, 4695,    0,    0,    0,    0,    0,  156,
 5046,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  462,    0,    0, 1020,    0,    0,    0,
    0,    0,    0,    0,    0,  564,  827,    0,    0, 4041,
 3914,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  713,    0,  713,    0,    0,  744,    0,    0,
    0,    0,    0,  108, 5078, 2721, 3727, 2099,    0, 5109,
    0,    0,    0, 4725,    0, 1225,    0,    0, 1027,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  768, 2221,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 3274,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1112,    0,    0,    0,
 1020,    0, 1020,    0, 1020,    0,    0,    0, 1020,    0,
 1020,    0,    0,    0,    0, 1152,    0,  516,    0,  197,
  476,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  836,    0,    0,    0,    0,    0,    0,  768,
 2221,    0,    0,    0,    0, 2221,    0, 5226,    0,    0,
  647,  186, 1038,    0,    0, 5226,    0,    0,  110, 1044,
    0,    0, 4835,    0,    0,    0,  715, 4882,    0,    0,
 1147,    0,    0,    0,  863,  804,    0,    0,    0, 1994,
 1591,    0,    0,    0,    0,    0,    0,  898,  903, 1986,
 2408,    0,    0,    0,    0, 3138, 4553, 2534, 4509, 4497,
 2496, 3091, 4390, 4485,    0,    0,    0,    0,    0, 1148,
    0,    0,    0,    0,    0, 1020,    0,    0,    0,    0,
    0,  865,    0,    0, 1147,    0,    0,    0,    0,    0,
    0, 3600,    0,  744, 1112, 4930,    0,    0, 4958,  864,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1066,    0, 1044,    0,    0,    0,
    0,    0, 1389, 1151,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1072,    0,    0, 1365, 4379,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  357,    0,    0,    0,
  432,    0,    0,    0,    0,    0,  913,    0,    0,    0,
    0,    0,  135,    0,    0,  215, 5226, 5226,  133,    0,
 5226,    0,    0,    0,  552,  552,    0,    0,    0,    0,
    0,    0,    0,  708,  153,    0,    0,    0,    0, 1069,
    0, 1679, 1240,    0,    0,  652,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 5226,    0,    0, 1152,  784,  577,  577,  577,
    0,   51,  577,  577, 1147,    0,    0,    0,    0,    0,
  866,    0,  550,    0,    0,    0,    0,    0,    0,    0,
 4004,    0,    0,    0,    0,  167,    0, 1074,    0,    0,
    0,  729,    0,    0,    0,    0, 1340,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   85,
    0,  725,    0,    0,    0,    0,    0,    0,  725,    0,
    0,    0,    0, 1069,    0,    0,    0,  741,    0,  715,
    0,    0, 1069,    0,    0, 1075,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 2280,    0,   85,
    0,    0,  538,  540,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 2663,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1161,    0,    0,    0,    0,    0,    0,    0,    0,  708,
  138,    0,    0,    0,    0,  972, 1846,    0,    0,    0,
    0,    0,    0,   85,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1481,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1481,    0,    0,    0,    0,
    0,    0,    0, 1411,    0,    0,    0,    0,    0,    0,
 1947,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 4183,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 4802,    0,
    0, 5013,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1143,    0,    0,    0,    0,    0, 1143,    0,
 2221,    0, 2221,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  590,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  654,    0,    0,    0,    0,
    0,    0, 1169,    0,  590,    0,    0, 1143,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  905,    0,    0, 1169,    0,    0,    0,    0,
    0,    0,    0,  923,    0,    0,    0,
};
const short yygindex[] = {                                      0,
    0,  -23,  -42, -139,  888,  494,  -43,   10,  608, -241,
    6, 1176,  -89, 1014,    8,   97, -186,    0,  750,   -4,
  -55,    0, -431,  -33,  -25,    0,  814, -105,  518,    0,
  535,    0,  239,   19,  182,    0,  939,    0, -146,  -34,
  -24,  278,  -73,  -29,   21,    0, 1024,  934,  826, 1023,
  931,    0,    0,    0,   74,  -86, -131,   58,  -93,  -38,
    0,  861,    0,  967, -245,    0, -199,    0,    0,   -5,
  651,  790,    0,    0,  -61, -299,    0, 1154,    0,    0,
    0,    0,    0,  257,    0,    0,    0,    0,    4, -184,
    0,  360,    0,    0,    0,    0,    0,    0,    0, -147,
    0,    0,    0,    0,    0,    0,    0,    0, -249,    0,
 -234,  -98,  687,    0,    0,    0,    0,    0,    0,    0,
  760,    0, -323,  810,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  954,    0,    0,    0,    0,    0,  882,
    0,    0,    0, 1818,    0,    0,  626,  631,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,
};
#define YYTABLESIZE 5495
const short yytable[] = {                                     102,
  111,  112,   60,   62,   64,   71,   34,   34,   19,   19,
   20,   20,  125,   47,   52,   50,  277,  348,  129,  230,
  367,   23,   23,  137,  321,  228,  224,  130,  213,   40,
   41,   42,  332,  152,  156,  157,  368,   34,   51,   19,
  159,   20,  146,  527,  161,  276,  331,  300,   70,  241,
  164,  335,   23,  187,  681,  152,  158,  515,  551,  186,
  413,   57,   58,  198,  152,  124,  159,  182,   38,  389,
   70,  136,  180,  178,  313,  179,  187,  181,  456,   55,
  461,  141,  186,  242,  153,   70,  206,  456,  205,  461,
  128,   16,  128,  268,  220,   59,  146,  165,  137,   21,
   21,  117,   46,  622,  188,  449,  153,   55,  516,  318,
  264,  312,  192,  194,  196,  153,   49,  200,  202,  249,
  253,   36,  256,   67,  258,   66,   43,  188,  185,  207,
   21,  208,  456,  208,  455,  321,  189,  207,  207,  124,
  152,  128,  244,  185,  117,  302,  136,  128,  161,  128,
  161,  230,  161,  296,  241,  140,  161,   67,  161,   66,
  162,  298,  299,   70,  317,  182,  124,   70,  540,  268,
  180,  178,  214,  179,  268,  181,  297,  127,  427,  127,
  387,  137,  206,  207,  205,  300,  391,   37,  242,   44,
  334,  153,  127,  282,  127,  128,  117,  128,  546,  253,
  646,  328,  254,  258,   56,  668,  307,  182,  268,  185,
  217,  212,  180,  178,  567,  179,   45,  181,  159,  523,
  118,   56,   56,   56,  208,  127,  142,  127,  249,   57,
   58,  370,   56,  207,  296,  337,  338,  301,   61,  374,
  301,  610,  124,  127,  285,  124,  124,  244,  117,   63,
  117,   56,  117,  144,  117,  301,  117,  297,  117,  282,
   35,  258,  545,  161,  303,  341,  304,  343,  305,  238,
  308,  150,  309,  284,  310,  405,  405,  394,   16,   23,
  479,  254,  121,  189,  120,   16,  526,  229,  182,  173,
   72,  217,  137,  180,  178,   65,  179,  151,  181,  214,
  220,  117,   16,  506,   65,   56,  151,  128,    9,   10,
  285,  183,  184,  151,  185,  555,  254,   56,   57,   58,
  256,  249,  190,   16,  313,  176,  177,  259,  460,  464,
  208,   16,   16,   23,  183,  184,  208,  185,  212,  284,
   65,  526,  121,  676,  120,  172,  415,  416,   50,   65,
  454,  255,  197,    9,   10,  152,  235,   21,  513,  425,
  509,  512,  232,  520,  128,  128,  319,  519,   16,  254,
  498,   51,   57,   58,   65,  171,  559,   16,    9,   10,
  387,  391,  151,   57,   58,  564,  405,  387,  391,   56,
  458,  463,  437,  439,  127,  258,  258,  307,  225,  592,
  307,  515,   16,    9,   10,  684,  153,  493,  456,  127,
  455,   21,  128,  233,  510,  307,  645,  320,  475,  478,
  182,  173,  175,  176,  177,  180,  178,   16,  179,  704,
  181,  146,  203,  457,  462,  498,   23,  127,  553,  554,
  117,  117,  127,  137,  529,  323,  703,   56,  324,   49,
  254,  254,  516,  530,  256,  256,  438,  440,  531,  207,
  423,  259,  259,  174,  175,  176,  177,  124,  330,    1,
  127,  204,  315,  558,  462,  315,  336,  172,  248,   57,
   58,  301,   55,   23,  342,  255,  255,  253,  258,  257,
  315,  215,  246,  124,  253,  258,   70,  743,  137,   65,
  119,  326,  403,  589,  259,  329,  706,  754,  707,    3,
  148,    3,  159,  267,   21,  158,  158,  158,  568,  158,
  403,  477,  588,  273,  121,  147,  120,   16,    3,  592,
  457,  457,  274,  158,  158,    2,  621,  462,  462,  275,
  628,  630,  632,  170,  174,  175,  176,  177,  726,  594,
  198,  590,  227,  591,  403,  128,  623,  128,  276,   65,
  119,   21,  311,  230,   23,  725,  158,  226,  649,  254,
  339,  740,  656,  729,  730,    5,  254,    5,  243,  660,
  244,  243,  325,  244,  637,  639,   50,   16,  739,  142,
  344,  142,  300,  268,    5,  300,  243,  594,  244,  590,
  158,  591,  669,  677,   40,  671,  128,  679,  142,   51,
  300,  206,   23,  205,  672,  419,  345,  185,  420,  688,
  185,   40,   40,  257,  257,   65,  454,   93,  151,  268,
  404,  268,   81,  589,   87,  185,  110,   82,   56,   83,
  482,  307,   21,   56,  700,  450,  451,  404,  482,  452,
  705,  442,  588,   16,  443,  124,   40,   70,  279,  280,
  281,   75,  207,  538,  286,  287,  288,  289,  290,  291,
  292,  293,  294,  295,  296,  297,  174,  175,  176,  177,
   54,  732,    9,   10,  731,  483,  127,   49,  127,  736,
   21,  511,   93,  483,  405,   93,  514,  517,  518,  152,
  255,  521,  522,  549,  127,  283,  165,  751,  361,   93,
   93,  405,   93,  182,  173,  362,  315,  484,  180,  178,
   92,  179,  363,  181,  366,    3,    3,    3,    3,    3,
    3,    3,  158,  158,  232,  327,    3,    3,    3,  168,
  748,   65,  119,  749,   93,    9,   10,  127,  552,  127,
  153,    3,    3,  300,    3,    3,  300,  148,  177,  446,
  158,  447,  147,  147,  147,  308,  147,  371,  308,   16,
  172,  283,  234,  177,  219,  177,   93,  376,  377,  375,
  143,  147,  143,  308,  192,  233,  418,  192,  603,  219,
  542,    5,    5,    5,    5,    5,    5,    5,  372,  143,
  171,  417,    5,    5,    5,  541,  142,  142,  319,  388,
  378,  185,  379,  147,  380,  227,  381,    5,    5,  219,
    5,    5,  243,  128,  244,  128,  185,  382,  185,    6,
  560,    8,    9,   10,  142,  383,  186,  409,   11,   12,
   13,  186,  647,  186,  186,  186,  186,  186,  186,  384,
  480,  481,   58,  385,   15,  386,   16,   74,   75,  320,
   76,  186,  186,  390,  186,  395,  148,   43,  436,  399,
   43,  401,  667,  227,  128,  407,  193,  408,   77,  193,
   17,  561,   78,   79,   43,   43,   80,  148,  690,  411,
  182,  173,   85,   86,  186,  180,  178,  414,  179,  421,
  181,  431,  692,  127,  127,  308,  184,  181,  308,  202,
  435,  441,   88,   89,   90,  471,   93,  444,  448,   43,
   91,  184,  181,  486,  202,  453,  186,  468,  186,  186,
  321,  127,  474,  495,  502,  321,   93,  321,  471,  321,
  321,   93,  321,   44,  503,  409,   44,  172,  409,   96,
   96,  504,   96,  534,   96,   96,  321,   96,   96,   96,
   44,   44,  505,  410,  127,  127,  410,  169,  170,  174,
  175,  176,  177,   96,  535,   96,  532,  171,  182,  147,
  147,  536,  147,  180,  178,  486,  179,  606,  181,  147,
  147,  147,  127,  543,  548,   44,  547,  143,  143,  177,
  607,  611,  550,   96,  351,  147,   96,  147,  609,  351,
  614,  351,  615,  351,  351,  617,  351,  486,  618,  619,
  321,  624,  182,  321,  626,  143,  486,  180,  633,  486,
  351,  486,  181,  634,  641,  635,   96,  636,  642,  650,
  128,  128,  659,  662,  604,  661,  182,  173,  664,  665,
  666,  180,  178,  674,  179,  608,  181,  678,  486,  186,
  186,  186,  186,  186,  186,  186,  186,  186,  616,  186,
  186,  186,  186,  186,  680,  186,  186,  186,  186,  186,
  186,  186,  186,  186,  186,  186,  186,  186,  682,  186,
  685,  186,  186,  687,  351,  186,  351,  351,  132,  133,
  134,  186,  186,  697,  322,   11,   12,   13,  698,  322,
  714,  322,  709,  322,  322,  712,  322,  718,  719,  724,
  186,  186,  186,  186,  186,  186,  186,  727,  186,  186,
  322,  525,  132,  133,  134,  734,  737,  738,  755,   11,
   12,   13,  101,  741,  745,  753,  174,  175,  176,  177,
  686,  277,   41,  321,  321,  321,  321,  321,  321,  321,
  321,  321,  278,  321,  321,  321,  321,  321,  275,  321,
  321,  321,  321,  321,  321,  321,  321,  321,  321,  321,
  321,  321,  321,  321,  321,  321,  321,  417,   42,  321,
  276,  419,  411,  206,  322,  321,  321,  322,  273,  274,
  399,  401,   96,   96,   96,   96,   96,   96,   96,  401,
   96,   96,  398,   96,  321,  321,  321,  321,  321,  321,
  321,  652,  321,  321,  128,  322,  528,  351,  351,  351,
  351,  351,  351,  351,  351,  351,  240,  351,  351,  351,
  351,  351,  733,  351,  351,  351,  351,  351,  351,  351,
  351,  351,  351,  351,  351,  351,  351,  351,  507,  351,
  351,  735,  396,  351,  141,  141,  141,  340,  141,  351,
  351,  406,  323,  508,  347,  410,  663,  323,  467,  323,
  640,  323,  323,  141,  323,  392,  544,  237,  351,  351,
  351,  351,  351,  351,  351,  566,  351,  351,  323,  539,
  412,  695,  174,  175,  176,  177,  696,    0,    0,    0,
  131,  132,  133,  134,  500,  141,    0,    0,   11,   12,
   13,   57,   58,  216,  217,  218,  219,  322,  322,  322,
  322,  322,  322,  322,  322,  322,   16,  322,  322,  322,
  322,  322,    0,  322,  322,  322,  322,  322,  322,  322,
  322,  322,  322,  322,  322,  322,  322,  322,    0,  322,
  322,    0,  323,  322,    0,  323,    0,    0,   48,  322,
  322,    0,  338,    0,    0,    0,    0,  338,    0,  338,
  476,  338,  338,    0,  338,    0,    0,    0,  322,  322,
  322,  322,  322,  322,  322,    0,  322,  322,  338,    0,
    0,    0,    0,    0,    0,   88,    0,  411,   88,  411,
  411,  411,  411,  411,    0,    0,  411,    0,  411,  411,
  411,    0,   88,   88,    0,   88,    0,   88,  127,  127,
  127,    0,  127,  239,  411,    6,    0,    8,    9,   10,
    0,    0,    0,  185,   11,   12,   13,  127,  185,    0,
  185,    0,  185,  185,    0,  185,    0,   88,    0,    0,
   15,    0,  338,   17,  316,  338,    0,    0,    0,  185,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  127,
    0,  141,  141,  141,  141,  141,  141,    0,    0,   88,
    0,  141,  141,  141,    0,  323,  323,  323,  323,  323,
  323,  323,  323,  323,    0,  323,  323,  323,  323,  323,
    0,  323,  323,  323,  323,  323,  323,  323,  323,  323,
  323,  323,  323,  323,  323,  323,    0,  323,  323,    0,
    0,  323,    0,  185,    0,  185,  185,  323,  323,  401,
   93,    0,    0,    0,    0,   81,    0,   87,    0,  110,
   82,    0,   83,    0,    0,    0,  323,  323,  323,  323,
  323,  323,  323,    0,  323,  323,  587,    6,    7,    8,
    9,   10,    0,    0,    0,    0,   11,   12,   13,    6,
   54,    8,    9,   10,    0,    0,    0,    0,   11,   12,
   13,    0,   15,    0,   16,    0,  338,  338,  338,  338,
  338,  338,  338,  338,   15,  338,  338,  338,  338,  338,
    0,  338,  338,  338,  338,  338,  338,  338,  338,  338,
  338,  338,  338,  338,  338,  338,    0,  338,  338,   88,
  276,  338,    0,   92,    0,    0,  638,  338,  338,    0,
    0,   93,    0,    0,    0,  127,   81,    0,   87,   88,
  110,   82,    0,   83,   88,   88,  338,  338,  338,  338,
  338,  338,  338,    0,  338,  338,  185,  185,  185,  185,
  185,  185,  185,  185,  185,    0,  185,  185,  185,  185,
  185,    0,  185,  185,  185,  185,  185,  185,  185,  185,
  185,  185,  185,  185,  185,    0,  185,    0,  185,  185,
    0,    0,  185,  136,  136,  136,    0,  136,  185,  185,
    0,  338,    0,  119,    0,    0,  338,    0,  338,    0,
  338,  338,  136,  338,    0,    0,    0,  185,  185,  185,
  185,  185,  185,  185,   92,  185,  185,  338,  387,  387,
  387,  387,  387,    0,    0,    0,    0,  387,  387,  387,
    0,    0,    0,    0,  136,    0,    0,    0,    0,    0,
    0,    0,    0,  387,  481,  569,    7,    8,    9,   10,
   74,   75,    0,   76,   11,   12,   13,  570,    0,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   15,   77,   16,   17,    0,   78,   79,    0,    0,   80,
    0,  338,    0,    0,  338,   85,   86,    0,   93,    0,
    0,    0,    0,   81,    0,   87,    0,  110,   82,    0,
   83,    0,    0,    0,  582,   88,   89,   90,  583,  584,
  585,    0,  586,   91,  587,    6,    7,    8,    9,   10,
    0,    0,    0,    0,   11,   12,   13,    0,  119,  119,
  119,  119,  119,    0,    0,  119,    0,  119,  119,  119,
   15,    0,   16,    0,    0,   73,    6,    7,    8,    9,
   10,   74,   75,  119,   76,   11,   12,   13,  338,    0,
    0,    0,    0,  338,    0,  338,    0,  338,  338,    0,
  338,   15,   77,   16,   17,    0,   78,   79,  276,    0,
   80,   92,    0,    0,  338,    0,   85,   86,    6,    7,
    8,    9,   10,    0,    0,    0,    0,   11,   12,   13,
  136,  136,    0,    0,    0,    0,   88,   89,   90,    0,
    0,    0,    0,   15,   91,  338,  338,  338,  338,  338,
  338,  338,  338,    0,  338,  338,  338,  338,  338,    0,
  338,  338,  338,  338,  338,  338,  338,  338,  338,  338,
  338,  338,  338,  338,  338,    0,  338,  338,  338,    0,
  338,  338,    0,    0,    0,    0,  338,  338,    0,  349,
    0,    0,    0,    0,  349,    0,  349,    0,  349,  349,
    0,  349,    0,    0,    0,  338,  338,  338,  338,  338,
  338,  338,    0,  338,  338,  349,    0,  239,    0,    6,
    0,    8,    9,   10,    0,    0,    0,    0,   11,   12,
   13,    0,    0,    0,    0,    0,   95,    0,    0,   95,
    0,    0,  481,   58,   15,    0,    0,   17,   74,   75,
    0,   76,    0,   95,   95,  570,    0,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,    0,   77,
    0,   17,    0,   78,   79,    0,    0,   80,    0,  349,
    0,    0,  349,   85,   86,    0,   93,    0,   95,    0,
    0,   81,    0,   87,    0,  110,   82,    0,   83,    0,
    0,    0,  582,   88,   89,   90,  583,  584,  585,    0,
  586,   91,  338,  338,    0,    0,    0,    0,  338,  338,
   95,  338,    0,    0,    0,  338,  116,  338,  338,  338,
  338,  338,  338,  338,  338,  338,  338,  338,    0,  338,
    0,  338,    0,  338,  338,    0,    0,  338,  137,  137,
  137,    0,  137,  338,  338,    0,   93,    0,    0,    0,
    0,   81,    0,   87,    0,  110,   82,  137,   83,    0,
    0,    0,  338,  338,  338,  338,  338,  338,  338,   92,
  338,  338,    0,    6,    0,    8,    9,   10,    0,    0,
    0,    0,   11,   12,   13,    0,    0,    0,    0,  137,
   93,    0,    0,    0,    0,   81,    0,  306,   15,  110,
   82,    0,   83,  349,  349,    0,    0,    0,    0,  349,
  349,    0,  349,    0,    0,    0,  349,    0,  349,  349,
  349,  349,  349,  349,  349,  349,  349,  349,  349,    0,
  349,    0,  349,    0,  349,  349,    0,    0,  349,   92,
    0,    0,    0,    0,  349,  349,    0,    0,    0,  116,
   95,  338,  338,  338,  338,  338,    0,    0,    0,    0,
  338,  338,  338,  349,  349,  349,  349,  349,  349,  349,
   95,  349,  349,    0,    0,   93,  338,    0,    0,    0,
   81,    0,   87,   92,  110,   82,    0,   83,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  160,
   73,    6,    0,    8,    9,   10,   74,   75,    0,   76,
   11,   12,   13,    0,    0,    0,    0,    0,    0,    0,
   91,    0,    0,   91,    0,    0,   15,   77,    0,   17,
    0,   78,   79,    0,    0,   80,    0,   91,   91,    0,
   91,   85,   86,  115,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  137,  137,    0,    0,    0,
    0,   88,   89,   90,    0,  470,    0,    0,   92,   91,
   73,    6,   91,    8,    9,   10,   74,   75,   93,   76,
   11,   12,   13,   81,    0,   87,    0,  110,   82,    0,
   83,    0,    0,    0,    0,    0,   15,   77,    0,   17,
    0,   78,   79,    0,   91,   80,    0,    0,    0,    0,
    0,   85,   86,    0,   73,    6,    0,    8,    9,   10,
   74,   75,    0,   76,   11,   12,   13,    0,    0,    0,
  651,   88,   89,   90,    0,    0,    0,    0,    0,   91,
   15,   77,    0,   17,    0,   78,   79,    0,   94,   80,
    0,   94,   93,    0,    0,   85,   86,   81,    0,   87,
    0,  262,   82,    0,   83,   94,   94,    0,  484,    0,
    0,   92,    0,    0,    0,   88,   89,   90,  338,  338,
  338,  338,  338,   91,    0,    0,    0,  338,  338,  338,
    0,    0,  694,    0,    0,    0,    0,    0,  469,   73,
   94,    0,    0,  338,    0,   74,   75,    0,   76,    0,
   93,    0,  263,  708,    0,   81,  711,   87,  713,  110,
   82,    0,   83,    0,    0,    0,   77,  722,   17,    0,
   78,   79,   94,   78,   80,    0,   78,    0,    0,   78,
   85,   86,    0,    0,   91,   92,    0,    0,    0,    0,
    0,    0,    0,   78,   78,    0,   78,    0,   78,  747,
   88,   89,   90,    0,   91,    0,    0,    0,   91,   91,
  316,   82,    0,  757,   82,   93,    0,   82,    0,    0,
   81,    0,   87,    0,  110,   82,    0,   83,   78,   78,
    0,   82,   82,    0,   82,    0,   82,    0,    0,    0,
    0,  480,   73,   92,    0,    0,    0,    0,   74,   75,
    0,   76,  349,  350,    6,    7,    8,    9,   10,   78,
   78,  351,    0,   11,   12,   13,   82,   82,    0,   77,
    0,   17,    0,   78,   79,  333,    0,   80,    0,   15,
   93,   16,    0,   85,   86,   81,    0,   87,    0,  110,
   82,    0,   83,    0,    0,    0,    0,   82,   82,    0,
    0,    0,    0,   88,   89,   90,    0,    0,   92,    0,
    0,   91,   94,    0,    0,    0,   73,    0,    0,    0,
    0,    0,   74,   75,   93,   76,    0,    0,    0,   81,
    0,   87,   94,  110,   82,    0,   83,    0,    0,    0,
  360,    0,  165,   77,  165,   17,    0,   78,   79,    0,
    0,   80,    0,    0,    0,    0,    0,   85,   86,    0,
   32,  165,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   92,   73,    0,    0,   88,   89,   90,
   74,   75,   93,   76,    0,   91,    0,   81,    0,   87,
    0,  110,   82,    0,   83,    0,    0,    0,    0,    0,
   78,   77,    0,   17,  231,   78,   79,    0,    0,   80,
    0,    0,    0,    0,  369,   85,   86,   92,  231,  231,
   78,  231,    0,    0,    0,   78,   78,   78,   78,   78,
   78,   78,    0,    0,    0,   88,   89,   90,   82,   73,
    0,    0,    0,   91,    0,   74,   75,   93,   76,    0,
    0,    0,   81,    0,   87,    0,  110,   82,   82,   83,
    0,    0,    0,   82,   82,   82,   77,    0,   17,    0,
   78,   79,    0,    0,   80,   92,    0,    0,    0,    0,
   85,   86,    0,  231,    0,  231,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   88,   89,   90,    0,   73,    0,    0,  393,   91,    0,
   74,   75,    0,   76,   93,    0,    0,    0,    0,   81,
    0,   87,    0,  556,   82,    0,   83,    0,    0,    0,
    0,   77,    0,   17,    0,   78,   79,    0,    0,   80,
   92,    0,    0,    0,    0,   85,   86,    0,   73,    0,
    0,    0,    0,    0,   74,   75,    0,   76,    0,  165,
  165,  165,  165,  165,  165,   88,   89,   90,    0,  165,
  165,  165,    0,   91,  557,   77,    0,   17,    0,   78,
   79,    0,    0,   80,    0,    0,   93,  165,    0,   85,
   86,   81,    0,   87,    0,  110,   82,    0,   83,    0,
    0,    0,    0,    0,    0,  160,   73,   92,    0,   88,
   89,   90,   74,   75,    0,   76,  231,   91,  231,  231,
  231,  231,  231,    0,    0,    0,    0,  231,  231,  231,
    0,    0,    0,   77,    0,   17,    0,   78,   79,    0,
    0,   80,  231,  231,   93,  231,  605,   85,   86,   81,
    0,   87,    0,  110,   82,    0,   83,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   88,   89,   90,
  620,   73,    0,    0,    0,   91,    0,   74,   75,   92,
   76,    0,    0,   93,    0,    0,    0,    0,   81,    0,
   87,    0,  110,   82,    0,   83,    0,    0,   77,    0,
   17,    0,   78,   79,    0,    0,   80,    0,    0,  627,
    0,    0,   85,   86,  349,    0,    6,    7,    8,    9,
   10,    0,    0,  351,    0,   11,   12,   13,    0,    0,
    0,    0,   88,   89,   90,    0,    0,   92,   73,    0,
   91,   15,    0,   16,   74,   75,    0,   76,    0,    0,
    0,   93,    0,    0,    0,    0,   81,    0,   87,    0,
  110,   82,    0,   83,    0,   77,    0,   17,   79,   78,
   79,   79,    0,   80,   79,    0,   92,  629,    0,   85,
   86,    0,    0,    0,    0,    0,    0,    0,   79,   79,
    0,   79,    0,   79,    0,    0,    0,    0,    0,   88,
   89,   90,    0,    0,    0,    0,    0,   91,    0,    0,
   73,    0,    0,    0,    0,    0,   74,   75,   83,   76,
    0,   83,   93,   79,   79,    0,    0,   81,    0,   87,
    0,  110,   82,    0,   83,   83,   83,   77,   83,   17,
   83,   78,   79,    0,   92,   80,    0,    0,  631,    0,
    0,   85,   86,    0,   79,   79,    6,    7,    8,    9,
   10,    0,    0,  466,    0,   11,   12,   13,   73,    0,
   83,   88,   89,   90,   74,   75,    0,   76,    0,   91,
   93,   15,    0,   16,    0,   81,    0,   87,    0,   84,
   82,    0,   83,    0,    0,   77,    0,   17,    0,   78,
   79,   83,   83,   80,    0,    0,    0,   73,    0,   85,
   86,    0,    0,   74,   75,   92,   76,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   88,
   89,   90,    0,    0,   77,    0,   17,   91,   78,   79,
    0,    0,   80,    0,    0,    0,   89,    0,   85,   86,
    0,   89,    0,   89,    0,   89,   89,    0,   89,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   88,   89,
   90,   92,    0,   92,    0,   73,   91,    0,    0,    0,
    0,   74,   75,    0,   76,    0,    0,    0,    0,   93,
    0,    0,    0,    0,   81,   79,   87,    0,   84,   82,
    0,   83,   77,    0,   17,    0,   78,   79,    0,    0,
   80,    0,    0,    0,    0,   79,   85,   86,    0,    0,
   79,   79,   79,   79,   79,   79,   79,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   88,   89,   90,   89,
    0,    0,   83,    0,   91,    0,   73,    0,    0,    0,
    0,    0,   74,   75,   93,   76,    0,    0,    0,   81,
    0,   87,   83,  110,   82,    0,   83,   83,   83,   83,
    0,    0,    0,   77,    0,   17,    0,   78,   79,    0,
    0,   80,   92,    0,    0,    0,    0,   85,   86,    0,
    0,    0,    0,   93,    0,    0,    0,    0,   81,    0,
  191,    0,  110,   82,   73,   83,    0,   88,   89,   90,
   74,   75,    0,   76,    0,   91,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  750,    0,    0,    0,
    0,   77,    0,   17,    0,   78,   79,    0,    0,   80,
    0,    0,    0,   93,    0,   85,   86,   92,   81,    0,
  193,    0,  110,   82,    0,   83,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   88,   89,   90,    0,    0,
   89,    0,    0,   91,    0,    0,   89,   89,    0,   89,
    0,    6,    7,    8,    9,   10,   92,    0,    0,    0,
   11,   12,   13,    0,    0,    0,    0,   89,    0,   89,
    0,   89,   89,    0,    0,   89,   15,    0,   16,    0,
    0,   89,   89,   73,    0,    0,    0,    0,   93,   74,
   75,    0,   76,   81,    0,  195,    0,  110,   82,    0,
   83,   89,   89,   89,    0,    0,   92,    0,    0,   89,
   77,    0,   17,    0,   78,   79,    0,    0,   80,    0,
    0,    0,    0,    0,   85,   86,    0,   93,    0,    0,
    0,    0,   81,    0,  199,    0,  110,   82,    0,   83,
    0,    0,    0,    0,   88,   89,   90,    0,   73,  159,
  159,  159,   91,  159,   74,   75,    0,   76,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  159,  159,    0,
    0,    0,    0,    0,    0,   77,    0,   17,    0,   78,
   79,   92,    0,   80,    0,    0,    0,   73,    0,   85,
   86,    0,   93,   74,   75,    0,   76,   81,    0,  201,
  159,  110,   82,    0,   83,    0,    0,    0,    0,   88,
   89,   90,    0,    0,   77,    0,   17,   91,   78,   79,
   92,    0,   80,    0,    0,    0,    0,    0,   85,   86,
    0,    0,    0,    0,  159,    0,    0,   73,    0,    0,
    0,    0,    0,   74,   75,    0,   76,    0,   88,   89,
   90,    0,    0,    0,    0,    0,   91,    0,    0,    0,
    0,    0,    0,    0,   77,    0,   17,    0,   78,   79,
    0,    0,   80,    0,    0,    0,    0,   93,   85,   86,
  230,    0,   81,    0,   87,   92,  110,   82,    0,   83,
    0,    0,    0,    0,  230,  230,    0,  230,   88,   89,
   90,    0,    0,    0,    0,    0,   91,    0,    0,    0,
    0,    0,   73,    0,    0,    0,    0,    0,   74,   75,
    0,   76,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   77,
    0,   17,    0,   78,   79,    0,    0,   80,    0,    0,
    0,   73,    0,   85,   86,    0,    0,   74,   75,  230,
   76,  230,    0,    0,    0,    0,  159,  159,    0,    0,
   92,    0,    0,   88,   89,   90,    0,    0,   77,    0,
   17,   91,   78,   79,    0,    0,   80,    0,    0,    0,
    0,    0,   85,   86,  159,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   88,   89,   90,    0,   73,    0,    0,    0,
   91,    0,   74,   75,    0,   76,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   77,    0,   17,    0,   78,   79,    0,
    0,   80,    0,    0,    0,    0,    0,   85,   86,    0,
   98,   98,    0,   98,   98,   98,   98,   98,   98,   98,
   98,    0,    0,    0,    0,    0,    0,   88,   89,   90,
    0,   98,   98,    0,   98,   91,   98,    0,    0,    0,
    0,    0,  230,    0,  230,  230,  230,  230,  230,    0,
    0,  397,    0,  230,  230,  230,    0,   74,   75,    0,
   76,    0,    0,    0,   98,    0,   98,   98,  230,  230,
    0,  230,    0,    0,    0,    0,    0,    0,   77,    0,
   17,    0,   78,   79,    0,    0,   80,    0,    0,    0,
    0,    0,   85,   86,    0,    0,    0,   98,   98,    0,
   96,   96,    0,   96,    0,   96,   96,   96,   96,   96,
   96,    0,   88,   89,   90,    0,    0,    0,    0,    0,
   91,   31,   96,    0,   96,    0,   96,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   45,   45,    0,
    0,   45,   45,   45,   45,   45,    0,   45,    0,    0,
    0,    0,    0,    0,   96,    0,    0,   96,   45,   45,
    0,   45,    0,   45,    0,    0,    0,    0,    0,    0,
    0,    0,  182,  173,    0,    0,    0,  180,  178,    0,
  179,    0,  181,    0,    0,    0,    0,   96,   96,    0,
    0,    0,    0,   45,   45,    0,  167,    0,  168,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  182,  173,    0,    0,    0,  180,  178,
    0,  179,    0,  181,   45,   45,    0,    0,  563,  172,
    0,    0,    0,    0,  658,    0,    0,  167,   98,  168,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   98,  171,
    0,    0,    0,   98,   98,   98,   98,   98,   98,   98,
  172,   98,   98,    0,   98,    0,    0,    0,    0,   45,
   45,    0,    0,    0,   45,   45,   45,   45,    0,   45,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  171,   45,    0,   45,    0,   45,    0,    0,    0,    0,
    0,  182,  173,    0,    0,    0,  180,  178,    0,  179,
    0,  181,  182,  173,    0,    0,    0,  180,  178,    0,
  179,    0,  181,    0,    0,  167,   45,  168,    0,    0,
    0,    0,    0,    0,    0,    0,  167,    0,  168,    0,
    0,    0,    0,   96,   96,   96,   96,   96,   96,   96,
    0,   96,   96,    0,   96,   45,   45,    0,  172,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  648,  172,
    0,    0,    0,    0,    0,   45,    0,    0,    0,    0,
   45,   45,   45,   45,   45,   45,   45,    0,  171,    0,
  562,    0,    0,    0,    0,    0,    0,    0,    0,  171,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  166,  169,  170,  174,  175,
  176,  177,  182,  173,    0,    0,    0,  180,  178,    0,
  179,  657,  181,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  702,  182,  173,  167,    0,  168,  180,
  178,    0,  179,    0,  181,    0,  166,  169,  170,  174,
  175,  176,  177,    0,    0,    0,    0,    0,  167,   86,
  168,    0,   86,    0,    0,    0,    0,   73,    0,  172,
   73,    0,   73,   73,   73,    0,   86,   86,    0,   86,
    0,   86,    0,    0,    0,    0,    0,   73,   73,    0,
   73,  172,   73,    0,    0,    0,    0,    0,    0,  171,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   86,   45,   45,   45,   45,   45,   45,   45,    0,
    0,  171,   73,   73,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   16,
    0,    0,    0,   86,  166,  169,  170,  174,  175,  176,
  177,    0,    0,   73,   73,  166,  169,  170,  174,  175,
  176,  177,   74,    0,    0,   74,    0,   74,   74,   74,
    0,    0,    0,    0,   80,    0,    0,   80,    0,    0,
   80,    0,   74,   74,    0,   74,   81,   74,    0,   81,
    0,    0,   81,    0,   80,   80,    0,   80,    0,   80,
    0,    0,    0,    0,    0,    0,   81,   81,    0,   81,
    0,   81,    0,    0,    0,    0,    0,   74,   74,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   80,
   80,    0,    0,   84,    0,    0,   84,    0,    0,    0,
    0,   81,   81,    0,    0,    0,    0,    0,   74,   74,
   84,   84,    0,   84,    0,   84,    0,    0,    0,    0,
   80,   80,    0,    0,    0,  166,  169,  170,  174,  175,
  176,  177,   81,   81,    0,    0,    0,  156,  156,  156,
    0,  156,    0,   86,    0,   84,   84,  166,  169,  170,
  174,  175,  176,  177,   73,  156,  156,    0,    0,    0,
    0,    0,    0,   86,    0,    0,    0,    0,   86,   86,
   86,    0,    0,    0,   73,    0,   84,   84,    0,   73,
   73,   73,   73,   73,   73,   73,  263,  263,  263,    0,
  263,    0,    0,    0,    0,    0,    0,    0,    0,  267,
  267,  267,    0,  267,  263,  263,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  267,  267,    0,
    0,    0,  156,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  272,  272,  272,  263,  272,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   74,
  267,    0,  272,  272,    0,    0,    0,    0,    0,    0,
    0,   80,    0,    0,  170,  170,  170,    0,  170,   74,
    0,  263,    0,   81,   74,   74,   74,   74,   74,   74,
   74,   80,  170,  170,  267,  272,   80,   80,   80,   80,
   80,    0,    0,   81,    0,    0,    0,    0,   81,   81,
   81,   81,  149,  149,  149,    0,  149,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   84,    0,  272,
    0,  149,  148,  148,  148,    0,  148,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   84,    0,    0,
    0,  148,   84,   84,   84,  177,    0,    0,    0,  170,
    0,    0,    0,  149,  156,  156,  156,  156,  156,  156,
  177,    0,  177,    0,  156,  156,  156,    0,    0,    0,
    0,    0,    0,  148,    0,  248,    0,    0,  248,    0,
  156,    0,  156,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  248,  248,    0,  248,    0,    0,    0,    0,
    0,    0,    0,  263,  263,  263,  263,  263,  263,    0,
    0,    0,    0,  263,  263,  263,  267,  267,  267,  267,
  267,  267,  252,    0,  224,  252,  267,  267,  267,    0,
    0,  263,    0,    0,    0,    0,    0,    0,    0,  252,
  252,    0,  252,    0,  267,    0,    0,    0,    0,    0,
    0,  272,  272,  272,  272,  272,  272,  248,    0,  248,
    0,  272,  272,  272,    0,    0,    0,    0,    0,    0,
  236,    0,    0,  236,    0,    0,    0,    0,    0,  272,
    0,  170,  170,  170,  170,  170,  170,  236,  236,    0,
  236,  170,  170,  170,    0,    0,    0,    0,  237,    0,
    0,  237,    0,    0,  252,    0,  252,    0,    0,  170,
    0,    0,    0,    0,    0,  237,  237,    0,  237,  149,
  149,    0,  149,    0,    0,    0,    0,    0,    0,  149,
  149,  149,    0,    0,  150,  150,  150,    0,  150,  148,
  148,  148,  148,  148,  148,  149,    0,  149,    0,  148,
  148,  148,  236,  150,  236,    0,  177,  224,    0,  224,
  224,  224,  224,  224,    0,  148,    0,    0,  224,  224,
  224,  177,    0,  177,    0,    0,    0,    0,    0,    0,
  237,    0,  237,    0,  224,  150,  177,    0,    0,  177,
  248,    0,  248,  248,  248,  248,  248,    0,    0,    0,
    0,  248,  248,  248,  177,    0,  177,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  248,  248,    0,  248,
    0,  177,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  227,  177,  252,  177,  252,
  252,  252,  252,  252,    0,    0,    0,    0,  252,  252,
  252,    0,  177,    0,    0,   18,    0,    0,    0,    0,
    0,    0,    0,  252,  252,    0,  252,  177,   27,  177,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  236,    0,  236,  236,  236,
  236,  236,    0,    0,    0,    0,  236,  236,  236,    0,
   19,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  236,  236,  237,  236,  237,  237,  237,  237,  237,
    0,    0,    0,    0,  237,  237,  237,    0,    0,    0,
    0,   23,    0,    0,    0,    0,    0,    0,    0,  237,
  237,    0,  237,    0,    0,    0,    0,    0,    0,    0,
    0,  150,  150,  150,  150,  150,  150,    0,    0,    0,
    0,  150,  150,  150,    0,  185,  185,  185,  227,  185,
  227,  227,  227,  227,  227,    0,    0,  150,    0,  227,
  227,  227,    0,  185,  185,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  227,    0,  177,    0,    0,
    0,    0,    0,   27,   27,   27,   27,   27,    0,    0,
    0,    0,   27,   27,   27,    0,  185,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   27,    0,
  177,    0,    0,    0,    0,   19,   19,   19,   19,   19,
    0,    0,    0,    0,   19,   19,   19,    0,    0,    0,
  185,    0,    5,    0,    6,    7,    8,    9,   10,    0,
   19,    0,  177,   11,   12,   13,   23,   23,   23,   23,
   23,    0,    0,    0,    0,   23,   23,   23,   14,   15,
    0,   16,   17,    0,    0,    0,    0,    0,    0,    0,
    0,   23,    0,  177,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  185,  185,  185,  185,  185,  185,    0,    0,
    0,    0,  185,  185,  185,
};
const short yycheck[] = {                                      38,
   43,   44,   26,   27,   28,   30,    3,    4,    3,    4,
    3,    4,   47,   19,   20,   20,  163,  259,   52,  125,
  270,    3,    4,   53,  211,  124,  120,   52,  115,   11,
   12,   13,  232,   40,   78,   79,  271,   34,   20,   34,
   84,   34,   67,  475,   87,  123,  231,  187,   30,  139,
   94,  236,   34,   40,   41,   40,   80,   40,   58,   46,
   41,  257,  258,  107,   40,   47,  110,   37,   91,  315,
   52,   53,   42,   43,  206,   45,   40,   47,   40,   22,
   42,   61,   46,  139,   91,   67,   40,   40,   42,   42,
   40,  285,   42,  155,  118,  123,  121,   44,  128,    3,
    4,   44,   59,   42,   91,  405,   91,   50,   91,  208,
  153,  205,  103,  104,  105,   91,   20,  108,  109,  143,
  145,   59,  148,   40,  149,   42,   40,   91,   44,   91,
   34,  113,   40,  115,   42,  322,  264,   91,   91,  121,
   40,   91,  139,   59,   87,  188,  128,   40,  191,   42,
  193,  257,  195,   44,  244,  123,  199,   40,  201,   42,
   87,  185,  186,  145,  207,   37,  148,  149,  492,  231,
   42,   43,  115,   45,  236,   47,   44,   40,  256,   42,
  312,  211,   40,   91,   42,  325,  318,  125,  244,   40,
  233,   91,   40,   59,   42,   40,  139,   42,  498,  224,
   40,  227,  145,  228,   23,  637,  197,   37,  270,  125,
   44,  115,   42,   43,  538,   45,   40,   47,  262,  465,
   40,   40,   41,   42,  206,   40,  123,   42,  252,  257,
  258,  275,   51,   91,  125,  241,  242,   41,  123,  282,
   44,  565,  224,   58,   59,  227,  228,  244,  191,  123,
  193,   70,  195,  123,  197,   59,  199,  125,  201,  125,
    4,  123,  497,  306,  191,  245,  193,  247,  195,  125,
  197,  256,  199,   59,  201,  337,  338,  320,  285,  261,
  427,  224,   40,  264,   42,  285,  473,  256,   37,   38,
   34,  125,  322,   42,   43,  257,   45,  282,   47,  242,
  324,  244,  285,  443,  257,  124,  282,  257,  261,  262,
  125,  298,  299,  282,  301,  515,  123,  136,  257,  258,
  123,  345,   93,  285,  456,  295,  296,  123,  415,  416,
  312,  285,  285,  315,  298,  299,  318,  301,  242,  125,
  257,  528,   40,  643,   42,   94,  352,  353,  353,  257,
  258,  123,   40,  261,  262,   40,  256,  261,  457,  364,
   58,  455,   40,  462,  257,  258,   40,  461,  285,  312,
  432,  353,  257,  258,  257,  124,  524,  285,  261,  262,
  512,  513,  282,  257,  258,  533,  448,  519,  520,  208,
  415,  416,  383,  384,  257,  257,  258,   41,  121,  546,
   44,   40,  285,  261,  262,  655,   91,  431,   40,  257,
   42,  315,  257,   91,  449,   59,  256,   91,  424,  425,
   37,   38,  294,  295,  296,   42,   43,  285,   45,   41,
   47,  456,   41,  415,  416,  497,  418,  285,  512,  513,
  383,  384,  257,  473,  478,   41,   58,  266,   44,  353,
  257,  258,   91,  478,  257,  258,  383,  384,  482,   91,
  364,  257,  258,  293,  294,  295,  296,  449,  230,    0,
  285,   41,   41,  516,  456,   44,  238,   94,  256,  257,
  258,  285,  425,  465,  246,  257,  258,  512,  513,  123,
   59,   41,  125,  475,  519,  520,  478,  739,  528,  257,
  258,  224,   41,  546,   40,  228,  691,  749,  693,   40,
   44,   42,  556,  256,  418,   40,   41,   42,  542,   44,
   59,  425,  546,   41,   40,   59,   42,  285,   59,  676,
  512,  513,   41,   58,   59,    0,  579,  519,  520,   41,
  583,  584,  585,  292,  293,  294,  295,  296,   41,  546,
  594,  546,   44,  546,   93,   40,  580,   42,  123,  257,
  258,  465,   59,  669,  546,   58,   91,   59,  611,  512,
   59,   41,  615,  720,  721,   40,  519,   42,   41,  622,
   41,   44,   40,   44,  590,  591,  591,  285,   58,   40,
   61,   42,   41,  655,   59,   44,   59,  594,   59,  594,
  125,  594,  637,  646,   41,  639,   91,  650,   59,  591,
   59,   40,  594,   42,  639,   41,   44,   41,   44,  662,
   44,   58,   59,  257,  258,  257,  258,   33,  282,  691,
   41,  693,   38,  676,   40,   59,   42,   43,  457,   45,
   46,  285,  546,  462,  683,  407,  408,   58,   46,  411,
  689,   41,  676,  285,   44,  637,   93,  639,  165,  166,
  167,  264,   91,   61,  171,  172,  173,  174,  175,  176,
  177,  178,  179,  180,  181,  182,  293,  294,  295,  296,
  259,  724,  261,  262,  723,   91,   40,  591,   42,  728,
  594,  453,   41,   91,   41,   44,  458,  459,  460,   40,
   41,  463,  464,   41,   58,   59,   44,  746,   93,   58,
   59,   58,   61,   37,   38,   61,  285,  123,   42,   43,
  126,   45,   59,   47,  265,  256,  257,  258,  259,  260,
  261,  262,  257,  258,   40,   41,  267,  268,  269,   63,
   41,  257,  258,   44,   93,  261,  262,   40,  510,   42,
   91,  282,  283,   41,  285,  286,   44,   44,   44,  400,
  285,  402,   40,   41,   42,   41,   44,   41,   44,  285,
   94,  125,   59,   59,   46,   61,  125,  284,  285,   58,
   40,   59,   42,   59,   41,   91,   44,   44,  550,   61,
   44,  256,  257,  258,  259,  260,  261,  262,  125,   59,
  124,   59,  267,  268,  269,   59,  257,  258,   40,   41,
   41,   44,   93,   91,   41,   44,   41,  282,  283,   91,
  285,  286,  285,   40,  285,   42,   59,   41,   61,  258,
   59,  260,  261,  262,  285,   44,   33,  344,  267,  268,
  269,   38,  604,   40,   41,   42,   43,   44,   45,   44,
  256,  257,  258,   41,  283,   41,  285,  263,  264,   91,
  266,   58,   59,   93,   61,   41,   44,   41,  375,   61,
   44,   93,  634,   44,   91,  125,   41,  125,  284,   44,
  286,   59,  288,  289,   58,   59,  292,   44,   59,  125,
   37,   38,  298,  299,   91,   42,   43,   41,   45,   41,
   47,  287,   59,  257,  258,   41,   44,   44,   44,   44,
   58,   93,  318,  319,  320,  422,  265,   41,   44,   93,
  326,   59,   59,  430,   59,  125,  123,  257,  125,  126,
   33,  285,   59,  256,   41,   38,  285,   40,  445,   42,
   43,  290,   45,   41,   41,   41,   44,   94,   44,   37,
   38,   41,   40,   58,   42,   43,   59,   45,   46,   47,
   58,   59,   41,   41,  257,  258,   44,  291,  292,  293,
  294,  295,  296,   61,  125,   63,  483,  124,   37,  257,
  258,   44,  260,   42,   43,  492,   45,   93,   47,  267,
  268,  269,  285,  125,  501,   93,  125,  257,  258,  285,
  125,   40,  509,   91,   33,  283,   94,  285,  125,   38,
   40,   40,   40,   42,   43,   58,   45,  524,   59,   59,
  123,  261,   37,  126,   40,  285,  533,   42,   59,  536,
   59,  538,   47,   58,  271,   59,  124,   59,  256,   40,
  257,  258,   59,   40,  551,   59,   37,   38,   59,   59,
   59,   42,   43,  256,   45,  562,   47,   41,  565,  256,
  257,  258,  259,  260,  261,  262,  263,  264,  575,  266,
  267,  268,  269,  270,  272,  272,  273,  274,  275,  276,
  277,  278,  279,  280,  281,  282,  283,  284,   59,  286,
   41,  288,  289,   59,  123,  292,  125,  126,  260,  261,
  262,  298,  299,   41,   33,  267,  268,  269,   41,   38,
  264,   40,   59,   42,   43,   59,   45,   59,   59,   40,
  317,  318,  319,  320,  321,  322,  323,   44,  325,  326,
   59,  259,  260,  261,  262,   59,   41,   41,   41,  267,
  268,  269,  123,   59,   59,   59,  293,  294,  295,  296,
  657,  125,   41,  256,  257,  258,  259,  260,  261,  262,
  263,  264,  125,  266,  267,  268,  269,  270,  125,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,   41,   41,  292,
  125,   41,   41,  125,  123,  298,  299,  126,  125,  125,
   40,   59,  290,  291,  292,  293,  294,  295,  296,   41,
  298,  299,  325,  301,  317,  318,  319,  320,  321,  322,
  323,  614,  325,  326,   49,  212,  477,  256,  257,  258,
  259,  260,  261,  262,  263,  264,   59,  266,  267,  268,
  269,  270,  725,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  445,  288,
  289,  727,  324,  292,   40,   41,   42,  244,   44,  298,
  299,  338,   33,  448,  252,  345,  626,   38,  418,   40,
  594,   42,   43,   59,   45,  319,  497,  134,  317,  318,
  319,  320,  321,  322,  323,  536,  325,  326,   59,  490,
  347,  676,  293,  294,  295,  296,  676,   -1,   -1,   -1,
  259,  260,  261,  262,  433,   91,   -1,   -1,  267,  268,
  269,  257,  258,  259,  260,  261,  262,  256,  257,  258,
  259,  260,  261,  262,  263,  264,  285,  266,  267,  268,
  269,  270,   -1,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,   -1,  288,
  289,   -1,  123,  292,   -1,  126,   -1,   -1,   59,  298,
  299,   -1,   33,   -1,   -1,   -1,   -1,   38,   -1,   40,
   59,   42,   43,   -1,   45,   -1,   -1,   -1,  317,  318,
  319,  320,  321,  322,  323,   -1,  325,  326,   59,   -1,
   -1,   -1,   -1,   -1,   -1,   41,   -1,  256,   44,  258,
  259,  260,  261,  262,   -1,   -1,  265,   -1,  267,  268,
  269,   -1,   58,   59,   -1,   61,   -1,   63,   40,   41,
   42,   -1,   44,  256,  283,  258,   -1,  260,  261,  262,
   -1,   -1,   -1,   33,  267,  268,  269,   59,   38,   -1,
   40,   -1,   42,   43,   -1,   45,   -1,   93,   -1,   -1,
  283,   -1,  123,  286,  125,  126,   -1,   -1,   -1,   59,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,
   -1,  257,  258,  259,  260,  261,  262,   -1,   -1,  125,
   -1,  267,  268,  269,   -1,  256,  257,  258,  259,  260,
  261,  262,  263,  264,   -1,  266,  267,  268,  269,  270,
   -1,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,   -1,  288,  289,   -1,
   -1,  292,   -1,  123,   -1,  125,  126,  298,  299,   59,
   33,   -1,   -1,   -1,   -1,   38,   -1,   40,   -1,   42,
   43,   -1,   45,   -1,   -1,   -1,  317,  318,  319,  320,
  321,  322,  323,   -1,  325,  326,   59,  258,  259,  260,
  261,  262,   -1,   -1,   -1,   -1,  267,  268,  269,  258,
  259,  260,  261,  262,   -1,   -1,   -1,   -1,  267,  268,
  269,   -1,  283,   -1,  285,   -1,  257,  258,  259,  260,
  261,  262,  263,  264,  283,  266,  267,  268,  269,  270,
   -1,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,   -1,  288,  289,  265,
  123,  292,   -1,  126,   -1,   -1,   59,  298,  299,   -1,
   -1,   33,   -1,   -1,   -1,  257,   38,   -1,   40,  285,
   42,   43,   -1,   45,  290,  291,  317,  318,  319,  320,
  321,  322,  323,   -1,  325,  326,  256,  257,  258,  259,
  260,  261,  262,  263,  264,   -1,  266,  267,  268,  269,
  270,   -1,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,   -1,  286,   -1,  288,  289,
   -1,   -1,  292,   40,   41,   42,   -1,   44,  298,  299,
   -1,   33,   -1,  123,   -1,   -1,   38,   -1,   40,   -1,
   42,   43,   59,   45,   -1,   -1,   -1,  317,  318,  319,
  320,  321,  322,  323,  126,  325,  326,   59,  258,  259,
  260,  261,  262,   -1,   -1,   -1,   -1,  267,  268,  269,
   -1,   -1,   -1,   -1,   91,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  283,  257,  258,  259,  260,  261,  262,
  263,  264,   -1,  266,  267,  268,  269,  270,   -1,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,  284,  285,  286,   -1,  288,  289,   -1,   -1,  292,
   -1,  123,   -1,   -1,  126,  298,  299,   -1,   33,   -1,
   -1,   -1,   -1,   38,   -1,   40,   -1,   42,   43,   -1,
   45,   -1,   -1,   -1,  317,  318,  319,  320,  321,  322,
  323,   -1,  325,  326,   59,  258,  259,  260,  261,  262,
   -1,   -1,   -1,   -1,  267,  268,  269,   -1,  258,  259,
  260,  261,  262,   -1,   -1,  265,   -1,  267,  268,  269,
  283,   -1,  285,   -1,   -1,  257,  258,  259,  260,  261,
  262,  263,  264,  283,  266,  267,  268,  269,   33,   -1,
   -1,   -1,   -1,   38,   -1,   40,   -1,   42,   43,   -1,
   45,  283,  284,  285,  286,   -1,  288,  289,  123,   -1,
  292,  126,   -1,   -1,   59,   -1,  298,  299,  258,  259,
  260,  261,  262,   -1,   -1,   -1,   -1,  267,  268,  269,
  257,  258,   -1,   -1,   -1,   -1,  318,  319,  320,   -1,
   -1,   -1,   -1,  283,  326,  257,  258,  259,  260,  261,
  262,  263,  264,   -1,  266,  267,  268,  269,  270,   -1,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,   -1,  288,  289,  123,   -1,
  292,  126,   -1,   -1,   -1,   -1,  298,  299,   -1,   33,
   -1,   -1,   -1,   -1,   38,   -1,   40,   -1,   42,   43,
   -1,   45,   -1,   -1,   -1,  317,  318,  319,  320,  321,
  322,  323,   -1,  325,  326,   59,   -1,  256,   -1,  258,
   -1,  260,  261,  262,   -1,   -1,   -1,   -1,  267,  268,
  269,   -1,   -1,   -1,   -1,   -1,   41,   -1,   -1,   44,
   -1,   -1,  257,  258,  283,   -1,   -1,  286,  263,  264,
   -1,  266,   -1,   58,   59,  270,   -1,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,   -1,  284,
   -1,  286,   -1,  288,  289,   -1,   -1,  292,   -1,  123,
   -1,   -1,  126,  298,  299,   -1,   33,   -1,   93,   -1,
   -1,   38,   -1,   40,   -1,   42,   43,   -1,   45,   -1,
   -1,   -1,  317,  318,  319,  320,  321,  322,  323,   -1,
  325,  326,  257,  258,   -1,   -1,   -1,   -1,  263,  264,
  125,  266,   -1,   -1,   -1,  270,  123,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,   -1,  284,
   -1,  286,   -1,  288,  289,   -1,   -1,  292,   40,   41,
   42,   -1,   44,  298,  299,   -1,   33,   -1,   -1,   -1,
   -1,   38,   -1,   40,   -1,   42,   43,   59,   45,   -1,
   -1,   -1,  317,  318,  319,  320,  321,  322,  323,  126,
  325,  326,   -1,  258,   -1,  260,  261,  262,   -1,   -1,
   -1,   -1,  267,  268,  269,   -1,   -1,   -1,   -1,   91,
   33,   -1,   -1,   -1,   -1,   38,   -1,   40,  283,   42,
   43,   -1,   45,  257,  258,   -1,   -1,   -1,   -1,  263,
  264,   -1,  266,   -1,   -1,   -1,  270,   -1,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,   -1,
  284,   -1,  286,   -1,  288,  289,   -1,   -1,  292,  126,
   -1,   -1,   -1,   -1,  298,  299,   -1,   -1,   -1,  256,
  265,  258,  259,  260,  261,  262,   -1,   -1,   -1,   -1,
  267,  268,  269,  317,  318,  319,  320,  321,  322,  323,
  285,  325,  326,   -1,   -1,   33,  283,   -1,   -1,   -1,
   38,   -1,   40,  126,   42,   43,   -1,   45,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,
  257,  258,   -1,  260,  261,  262,  263,  264,   -1,  266,
  267,  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   41,   -1,   -1,   44,   -1,   -1,  283,  284,   -1,  286,
   -1,  288,  289,   -1,   -1,  292,   -1,   58,   59,   -1,
   61,  298,  299,  123,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,  258,   -1,   -1,   -1,
   -1,  318,  319,  320,   -1,  123,   -1,   -1,  126,  326,
  257,  258,   93,  260,  261,  262,  263,  264,   33,  266,
  267,  268,  269,   38,   -1,   40,   -1,   42,   43,   -1,
   45,   -1,   -1,   -1,   -1,   -1,  283,  284,   -1,  286,
   -1,  288,  289,   -1,  125,  292,   -1,   -1,   -1,   -1,
   -1,  298,  299,   -1,  257,  258,   -1,  260,  261,  262,
  263,  264,   -1,  266,  267,  268,  269,   -1,   -1,   -1,
  613,  318,  319,  320,   -1,   -1,   -1,   -1,   -1,  326,
  283,  284,   -1,  286,   -1,  288,  289,   -1,   41,  292,
   -1,   44,   33,   -1,   -1,  298,  299,   38,   -1,   40,
   -1,   42,   43,   -1,   45,   58,   59,   -1,  123,   -1,
   -1,  126,   -1,   -1,   -1,  318,  319,  320,  258,  259,
  260,  261,  262,  326,   -1,   -1,   -1,  267,  268,  269,
   -1,   -1,  675,   -1,   -1,   -1,   -1,   -1,  256,  257,
   93,   -1,   -1,  283,   -1,  263,  264,   -1,  266,   -1,
   33,   -1,   93,  696,   -1,   38,  699,   40,  701,   42,
   43,   -1,   45,   -1,   -1,   -1,  284,  710,  286,   -1,
  288,  289,  125,   38,  292,   -1,   41,   -1,   -1,   44,
  298,  299,   -1,   -1,  265,  126,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   -1,   61,   -1,   63,  742,
  318,  319,  320,   -1,  285,   -1,   -1,   -1,  326,  290,
   93,   38,   -1,  756,   41,   33,   -1,   44,   -1,   -1,
   38,   -1,   40,   -1,   42,   43,   -1,   45,   93,   94,
   -1,   58,   59,   -1,   61,   -1,   63,   -1,   -1,   -1,
   -1,  256,  257,  126,   -1,   -1,   -1,   -1,  263,  264,
   -1,  266,  256,  257,  258,  259,  260,  261,  262,  124,
  125,  265,   -1,  267,  268,  269,   93,   94,   -1,  284,
   -1,  286,   -1,  288,  289,   93,   -1,  292,   -1,  283,
   33,  285,   -1,  298,  299,   38,   -1,   40,   -1,   42,
   43,   -1,   45,   -1,   -1,   -1,   -1,  124,  125,   -1,
   -1,   -1,   -1,  318,  319,  320,   -1,   -1,  126,   -1,
   -1,  326,  265,   -1,   -1,   -1,  257,   -1,   -1,   -1,
   -1,   -1,  263,  264,   33,  266,   -1,   -1,   -1,   38,
   -1,   40,  285,   42,   43,   -1,   45,   -1,   -1,   -1,
   93,   -1,   40,  284,   42,  286,   -1,  288,  289,   -1,
   -1,  292,   -1,   -1,   -1,   -1,   -1,  298,  299,   -1,
   58,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  126,  257,   -1,   -1,  318,  319,  320,
  263,  264,   33,  266,   -1,  326,   -1,   38,   -1,   40,
   -1,   42,   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,
  265,  284,   -1,  286,   44,  288,  289,   -1,   -1,  292,
   -1,   -1,   -1,   -1,  123,  298,  299,  126,   58,   59,
  285,   61,   -1,   -1,   -1,  290,  291,  292,  293,  294,
  295,  296,   -1,   -1,   -1,  318,  319,  320,  265,  257,
   -1,   -1,   -1,  326,   -1,  263,  264,   33,  266,   -1,
   -1,   -1,   38,   -1,   40,   -1,   42,   43,  285,   45,
   -1,   -1,   -1,  290,  291,  292,  284,   -1,  286,   -1,
  288,  289,   -1,   -1,  292,  126,   -1,   -1,   -1,   -1,
  298,  299,   -1,  123,   -1,  125,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  318,  319,  320,   -1,  257,   -1,   -1,   93,  326,   -1,
  263,  264,   -1,  266,   33,   -1,   -1,   -1,   -1,   38,
   -1,   40,   -1,   42,   43,   -1,   45,   -1,   -1,   -1,
   -1,  284,   -1,  286,   -1,  288,  289,   -1,   -1,  292,
  126,   -1,   -1,   -1,   -1,  298,  299,   -1,  257,   -1,
   -1,   -1,   -1,   -1,  263,  264,   -1,  266,   -1,  257,
  258,  259,  260,  261,  262,  318,  319,  320,   -1,  267,
  268,  269,   -1,  326,   93,  284,   -1,  286,   -1,  288,
  289,   -1,   -1,  292,   -1,   -1,   33,  285,   -1,  298,
  299,   38,   -1,   40,   -1,   42,   43,   -1,   45,   -1,
   -1,   -1,   -1,   -1,   -1,  256,  257,  126,   -1,  318,
  319,  320,  263,  264,   -1,  266,  256,  326,  258,  259,
  260,  261,  262,   -1,   -1,   -1,   -1,  267,  268,  269,
   -1,   -1,   -1,  284,   -1,  286,   -1,  288,  289,   -1,
   -1,  292,  282,  283,   33,  285,   93,  298,  299,   38,
   -1,   40,   -1,   42,   43,   -1,   45,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  318,  319,  320,
   59,  257,   -1,   -1,   -1,  326,   -1,  263,  264,  126,
  266,   -1,   -1,   33,   -1,   -1,   -1,   -1,   38,   -1,
   40,   -1,   42,   43,   -1,   45,   -1,   -1,  284,   -1,
  286,   -1,  288,  289,   -1,   -1,  292,   -1,   -1,   59,
   -1,   -1,  298,  299,  256,   -1,  258,  259,  260,  261,
  262,   -1,   -1,  265,   -1,  267,  268,  269,   -1,   -1,
   -1,   -1,  318,  319,  320,   -1,   -1,  126,  257,   -1,
  326,  283,   -1,  285,  263,  264,   -1,  266,   -1,   -1,
   -1,   33,   -1,   -1,   -1,   -1,   38,   -1,   40,   -1,
   42,   43,   -1,   45,   -1,  284,   -1,  286,   38,  288,
  289,   41,   -1,  292,   44,   -1,  126,   59,   -1,  298,
  299,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   -1,   61,   -1,   63,   -1,   -1,   -1,   -1,   -1,  318,
  319,  320,   -1,   -1,   -1,   -1,   -1,  326,   -1,   -1,
  257,   -1,   -1,   -1,   -1,   -1,  263,  264,   41,  266,
   -1,   44,   33,   93,   94,   -1,   -1,   38,   -1,   40,
   -1,   42,   43,   -1,   45,   58,   59,  284,   61,  286,
   63,  288,  289,   -1,  126,  292,   -1,   -1,   59,   -1,
   -1,  298,  299,   -1,  124,  125,  258,  259,  260,  261,
  262,   -1,   -1,  265,   -1,  267,  268,  269,  257,   -1,
   93,  318,  319,  320,  263,  264,   -1,  266,   -1,  326,
   33,  283,   -1,  285,   -1,   38,   -1,   40,   -1,   42,
   43,   -1,   45,   -1,   -1,  284,   -1,  286,   -1,  288,
  289,  124,  125,  292,   -1,   -1,   -1,  257,   -1,  298,
  299,   -1,   -1,  263,  264,  126,  266,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  318,
  319,  320,   -1,   -1,  284,   -1,  286,  326,  288,  289,
   -1,   -1,  292,   -1,   -1,   -1,   33,   -1,  298,  299,
   -1,   38,   -1,   40,   -1,   42,   43,   -1,   45,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  318,  319,
  320,   58,   -1,  126,   -1,  257,  326,   -1,   -1,   -1,
   -1,  263,  264,   -1,  266,   -1,   -1,   -1,   -1,   33,
   -1,   -1,   -1,   -1,   38,  265,   40,   -1,   42,   43,
   -1,   45,  284,   -1,  286,   -1,  288,  289,   -1,   -1,
  292,   -1,   -1,   -1,   -1,  285,  298,  299,   -1,   -1,
  290,  291,  292,  293,  294,  295,  296,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  318,  319,  320,  126,
   -1,   -1,  265,   -1,  326,   -1,  257,   -1,   -1,   -1,
   -1,   -1,  263,  264,   33,  266,   -1,   -1,   -1,   38,
   -1,   40,  285,   42,   43,   -1,   45,  290,  291,  292,
   -1,   -1,   -1,  284,   -1,  286,   -1,  288,  289,   -1,
   -1,  292,  126,   -1,   -1,   -1,   -1,  298,  299,   -1,
   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,   38,   -1,
   40,   -1,   42,   43,  257,   45,   -1,  318,  319,  320,
  263,  264,   -1,  266,   -1,  326,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  279,   -1,   -1,   -1,
   -1,  284,   -1,  286,   -1,  288,  289,   -1,   -1,  292,
   -1,   -1,   -1,   33,   -1,  298,  299,  126,   38,   -1,
   40,   -1,   42,   43,   -1,   45,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  318,  319,  320,   -1,   -1,
  257,   -1,   -1,  326,   -1,   -1,  263,  264,   -1,  266,
   -1,  258,  259,  260,  261,  262,  126,   -1,   -1,   -1,
  267,  268,  269,   -1,   -1,   -1,   -1,  284,   -1,  286,
   -1,  288,  289,   -1,   -1,  292,  283,   -1,  285,   -1,
   -1,  298,  299,  257,   -1,   -1,   -1,   -1,   33,  263,
  264,   -1,  266,   38,   -1,   40,   -1,   42,   43,   -1,
   45,  318,  319,  320,   -1,   -1,  126,   -1,   -1,  326,
  284,   -1,  286,   -1,  288,  289,   -1,   -1,  292,   -1,
   -1,   -1,   -1,   -1,  298,  299,   -1,   33,   -1,   -1,
   -1,   -1,   38,   -1,   40,   -1,   42,   43,   -1,   45,
   -1,   -1,   -1,   -1,  318,  319,  320,   -1,  257,   40,
   41,   42,  326,   44,  263,  264,   -1,  266,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   -1,
   -1,   -1,   -1,   -1,   -1,  284,   -1,  286,   -1,  288,
  289,  126,   -1,  292,   -1,   -1,   -1,  257,   -1,  298,
  299,   -1,   33,  263,  264,   -1,  266,   38,   -1,   40,
   91,   42,   43,   -1,   45,   -1,   -1,   -1,   -1,  318,
  319,  320,   -1,   -1,  284,   -1,  286,  326,  288,  289,
  126,   -1,  292,   -1,   -1,   -1,   -1,   -1,  298,  299,
   -1,   -1,   -1,   -1,  125,   -1,   -1,  257,   -1,   -1,
   -1,   -1,   -1,  263,  264,   -1,  266,   -1,  318,  319,
  320,   -1,   -1,   -1,   -1,   -1,  326,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  284,   -1,  286,   -1,  288,  289,
   -1,   -1,  292,   -1,   -1,   -1,   -1,   33,  298,  299,
   44,   -1,   38,   -1,   40,  126,   42,   43,   -1,   45,
   -1,   -1,   -1,   -1,   58,   59,   -1,   61,  318,  319,
  320,   -1,   -1,   -1,   -1,   -1,  326,   -1,   -1,   -1,
   -1,   -1,  257,   -1,   -1,   -1,   -1,   -1,  263,  264,
   -1,  266,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  284,
   -1,  286,   -1,  288,  289,   -1,   -1,  292,   -1,   -1,
   -1,  257,   -1,  298,  299,   -1,   -1,  263,  264,  123,
  266,  125,   -1,   -1,   -1,   -1,  257,  258,   -1,   -1,
  126,   -1,   -1,  318,  319,  320,   -1,   -1,  284,   -1,
  286,  326,  288,  289,   -1,   -1,  292,   -1,   -1,   -1,
   -1,   -1,  298,  299,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  318,  319,  320,   -1,  257,   -1,   -1,   -1,
  326,   -1,  263,  264,   -1,  266,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  284,   -1,  286,   -1,  288,  289,   -1,
   -1,  292,   -1,   -1,   -1,   -1,   -1,  298,  299,   -1,
   37,   38,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,   -1,  318,  319,  320,
   -1,   58,   59,   -1,   61,  326,   63,   -1,   -1,   -1,
   -1,   -1,  256,   -1,  258,  259,  260,  261,  262,   -1,
   -1,  257,   -1,  267,  268,  269,   -1,  263,  264,   -1,
  266,   -1,   -1,   -1,   91,   -1,   93,   94,  282,  283,
   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,  284,   -1,
  286,   -1,  288,  289,   -1,   -1,  292,   -1,   -1,   -1,
   -1,   -1,  298,  299,   -1,   -1,   -1,  124,  125,   -1,
   37,   38,   -1,   40,   -1,   42,   43,   44,   45,   46,
   47,   -1,  318,  319,  320,   -1,   -1,   -1,   -1,   -1,
  326,   58,   59,   -1,   61,   -1,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   37,   38,   -1,
   -1,   41,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   -1,   94,   58,   59,
   -1,   61,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   37,   38,   -1,   -1,   -1,   42,   43,   -1,
   45,   -1,   47,   -1,   -1,   -1,   -1,  124,  125,   -1,
   -1,   -1,   -1,   93,   94,   -1,   61,   -1,   63,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   37,   38,   -1,   -1,   -1,   42,   43,
   -1,   45,   -1,   47,  124,  125,   -1,   -1,   93,   94,
   -1,   -1,   -1,   -1,   58,   -1,   -1,   61,  265,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  285,  124,
   -1,   -1,   -1,  290,  291,  292,  293,  294,  295,  296,
   94,  298,  299,   -1,  301,   -1,   -1,   -1,   -1,   37,
   38,   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  124,   59,   -1,   61,   -1,   63,   -1,   -1,   -1,   -1,
   -1,   37,   38,   -1,   -1,   -1,   42,   43,   -1,   45,
   -1,   47,   37,   38,   -1,   -1,   -1,   42,   43,   -1,
   45,   -1,   47,   -1,   -1,   61,   94,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   61,   -1,   63,   -1,
   -1,   -1,   -1,  290,  291,  292,  293,  294,  295,  296,
   -1,  298,  299,   -1,  301,  265,  124,   -1,   94,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   94,
   -1,   -1,   -1,   -1,   -1,  285,   -1,   -1,   -1,   -1,
  290,  291,  292,  293,  294,  295,  296,   -1,  124,   -1,
  265,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  290,  291,  292,  293,  294,
  295,  296,   37,   38,   -1,   -1,   -1,   42,   43,   -1,
   45,  265,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   37,   38,   61,   -1,   63,   42,
   43,   -1,   45,   -1,   47,   -1,  290,  291,  292,  293,
  294,  295,  296,   -1,   -1,   -1,   -1,   -1,   61,   41,
   63,   -1,   44,   -1,   -1,   -1,   -1,   38,   -1,   94,
   41,   -1,   43,   44,   45,   -1,   58,   59,   -1,   61,
   -1,   63,   -1,   -1,   -1,   -1,   -1,   58,   59,   -1,
   61,   94,   63,   -1,   -1,   -1,   -1,   -1,   -1,  124,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   93,  290,  291,  292,  293,  294,  295,  296,   -1,
   -1,  124,   93,   94,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  285,
   -1,   -1,   -1,  125,  290,  291,  292,  293,  294,  295,
  296,   -1,   -1,  124,  125,  290,  291,  292,  293,  294,
  295,  296,   38,   -1,   -1,   41,   -1,   43,   44,   45,
   -1,   -1,   -1,   -1,   38,   -1,   -1,   41,   -1,   -1,
   44,   -1,   58,   59,   -1,   61,   38,   63,   -1,   41,
   -1,   -1,   44,   -1,   58,   59,   -1,   61,   -1,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   -1,   61,
   -1,   63,   -1,   -1,   -1,   -1,   -1,   93,   94,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,
   94,   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,
   -1,   93,   94,   -1,   -1,   -1,   -1,   -1,  124,  125,
   58,   59,   -1,   61,   -1,   63,   -1,   -1,   -1,   -1,
  124,  125,   -1,   -1,   -1,  290,  291,  292,  293,  294,
  295,  296,  124,  125,   -1,   -1,   -1,   40,   41,   42,
   -1,   44,   -1,  265,   -1,   93,   94,  290,  291,  292,
  293,  294,  295,  296,  265,   58,   59,   -1,   -1,   -1,
   -1,   -1,   -1,  285,   -1,   -1,   -1,   -1,  290,  291,
  292,   -1,   -1,   -1,  285,   -1,  124,  125,   -1,  290,
  291,  292,  293,  294,  295,  296,   40,   41,   42,   -1,
   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   41,   42,   -1,   44,   58,   59,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   -1,
   -1,   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   40,   41,   42,   91,   44,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  265,
   91,   -1,   58,   59,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  265,   -1,   -1,   40,   41,   42,   -1,   44,  285,
   -1,  125,   -1,  265,  290,  291,  292,  293,  294,  295,
  296,  285,   58,   59,  125,   91,  290,  291,  292,  293,
  294,   -1,   -1,  285,   -1,   -1,   -1,   -1,  290,  291,
  292,  293,   40,   41,   42,   -1,   44,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  265,   -1,  125,
   -1,   59,   40,   41,   42,   -1,   44,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  285,   -1,   -1,
   -1,   59,  290,  291,  292,   44,   -1,   -1,   -1,  125,
   -1,   -1,   -1,   91,  257,  258,  259,  260,  261,  262,
   59,   -1,   61,   -1,  267,  268,  269,   -1,   -1,   -1,
   -1,   -1,   -1,   91,   -1,   41,   -1,   -1,   44,   -1,
  283,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   -1,   61,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,  258,  259,  260,  261,  262,   -1,
   -1,   -1,   -1,  267,  268,  269,  257,  258,  259,  260,
  261,  262,   41,   -1,  123,   44,  267,  268,  269,   -1,
   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   -1,   61,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,  257,  258,  259,  260,  261,  262,  123,   -1,  125,
   -1,  267,  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,
   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,  285,
   -1,  257,  258,  259,  260,  261,  262,   58,   59,   -1,
   61,  267,  268,  269,   -1,   -1,   -1,   -1,   41,   -1,
   -1,   44,   -1,   -1,  123,   -1,  125,   -1,   -1,  285,
   -1,   -1,   -1,   -1,   -1,   58,   59,   -1,   61,  257,
  258,   -1,  260,   -1,   -1,   -1,   -1,   -1,   -1,  267,
  268,  269,   -1,   -1,   40,   41,   42,   -1,   44,  257,
  258,  259,  260,  261,  262,  283,   -1,  285,   -1,  267,
  268,  269,  123,   59,  125,   -1,   44,  256,   -1,  258,
  259,  260,  261,  262,   -1,  283,   -1,   -1,  267,  268,
  269,   59,   -1,   61,   -1,   -1,   -1,   -1,   -1,   -1,
  123,   -1,  125,   -1,  283,   91,  285,   -1,   -1,   44,
  256,   -1,  258,  259,  260,  261,  262,   -1,   -1,   -1,
   -1,  267,  268,  269,   59,   -1,   61,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  282,  283,   -1,  285,
   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  123,   59,  256,   61,  258,
  259,  260,  261,  262,   -1,   -1,   -1,   -1,  267,  268,
  269,   -1,   44,   -1,   -1,   59,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  282,  283,   -1,  285,   59,  123,   61,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  256,   -1,  258,  259,  260,
  261,  262,   -1,   -1,   -1,   -1,  267,  268,  269,   -1,
  123,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  282,  283,  256,  285,  258,  259,  260,  261,  262,
   -1,   -1,   -1,   -1,  267,  268,  269,   -1,   -1,   -1,
   -1,  123,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  282,
  283,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,  258,  259,  260,  261,  262,   -1,   -1,   -1,
   -1,  267,  268,  269,   -1,   40,   41,   42,  256,   44,
  258,  259,  260,  261,  262,   -1,   -1,  283,   -1,  267,
  268,  269,   -1,   58,   59,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  283,   -1,  285,   -1,   -1,
   -1,   -1,   -1,  258,  259,  260,  261,  262,   -1,   -1,
   -1,   -1,  267,  268,  269,   -1,   91,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  283,   -1,
  285,   -1,   -1,   -1,   -1,  258,  259,  260,  261,  262,
   -1,   -1,   -1,   -1,  267,  268,  269,   -1,   -1,   -1,
  125,   -1,  256,   -1,  258,  259,  260,  261,  262,   -1,
  283,   -1,  285,  267,  268,  269,  258,  259,  260,  261,
  262,   -1,   -1,   -1,   -1,  267,  268,  269,  282,  283,
   -1,  285,  286,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  283,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,  258,  259,  260,  261,  262,   -1,   -1,
   -1,   -1,  267,  268,  269,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 326
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'!'",0,0,0,"'%'","'&'",0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,
0,0,0,0,0,0,0,"':'","';'",0,"'='",0,"'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,"'['",0,"']'","'^'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'{'","'|'","'}'","'~'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"IDENTIFIER","TYPENAME",
"SCSPEC","TYPESPEC","TYPE_QUAL","TYPE_QUAL_S","CONSTANT","STRING","ELLIPSIS",
"SIZEOF","ENUM","STRUCT","UNION","IF","ELSE","WHILE","DO","FOR","SWITCH","CASE",
"DEFAULT","BREAK","CONTINUE","RETURN","GOTO","ASM_KEYWORD","TYPEOF","ALIGNOF",
"ATTRIBUTE","EXTENSION","LABEL","REALPART","IMAGPART","ASSIGN","OROR","ANDAND",
"EQCOMPARE","ARITHCOMPARE","LSHIFT","RSHIFT","UNARY","PLUSPLUS","MINUSMINUS",
"HYPERUNARY","POINTSAT","INTERFACE","IMPLEMENTATION","END","SELECTOR","DEFS",
"ENCODE","CLASSNAME","PUBLIC","PRIVATE","PROTECTED","PROTOCOL","OBJECTNAME",
"CLASS","ALIAS","OBJC_STRING","FORALL","UPC_BLOCKSIZEOF","UPC_LOCALSIZEOF",
"UPC_ELEMSIZEOF","UPC_BARRIER","UPC_NOTIFY","UPC_WAIT","END_OF_LINE",
"UPC_FENCE","BUPC_ASSERT_TYPE",
};
const char * const yyrule[] = {
"$accept : program",
"program :",
"program : extdefs",
"$$1 :",
"extdefs : $$1 extdef",
"$$2 :",
"extdefs : extdefs $$2 extdef",
"extdef : fndef",
"extdef : datadef",
"extdef : ASM_KEYWORD '(' expr ')' ';'",
"extdef : extension extdef",
"datadef : setspecs notype_initdecls ';'",
"datadef : declmods setspecs notype_initdecls ';'",
"datadef : typed_declspecs setspecs initdecls ';'",
"datadef : declmods ';'",
"datadef : typed_declspecs ';'",
"datadef : error ';'",
"datadef : error '}'",
"datadef : ';'",
"$$3 :",
"$$4 :",
"fndef : typed_declspecs setspecs declarator $$3 old_style_parm_decls $$4 compstmt_or_error",
"fndef : typed_declspecs setspecs declarator error",
"$$5 :",
"$$6 :",
"fndef : declmods setspecs notype_declarator $$5 old_style_parm_decls $$6 compstmt_or_error",
"fndef : declmods setspecs notype_declarator error",
"$$7 :",
"$$8 :",
"fndef : setspecs notype_declarator $$7 old_style_parm_decls $$8 compstmt_or_error",
"fndef : setspecs notype_declarator error",
"identifier : IDENTIFIER",
"identifier : TYPENAME",
"unop : '&'",
"unop : '-'",
"unop : '+'",
"unop : PLUSPLUS",
"unop : MINUSMINUS",
"unop : '~'",
"unop : '!'",
"expr : nonnull_exprlist",
"exprlist :",
"exprlist : nonnull_exprlist",
"nonnull_exprlist : expr_no_commas",
"nonnull_exprlist : nonnull_exprlist ',' expr_no_commas",
"unary_expr : primary",
"unary_expr : '*' cast_expr",
"unary_expr : extension cast_expr",
"unary_expr : unop cast_expr",
"unary_expr : ANDAND identifier",
"unary_expr : sizeof unary_expr",
"unary_expr : sizeof '(' typename ')'",
"unary_expr : upc_blocksizeof unary_expr",
"unary_expr : upc_blocksizeof '(' typename ')'",
"unary_expr : upc_localsizeof unary_expr",
"unary_expr : upc_localsizeof '(' typename ')'",
"unary_expr : upc_elemsizeof unary_expr",
"unary_expr : upc_elemsizeof '(' typename ')'",
"unary_expr : alignof unary_expr",
"unary_expr : alignof '(' typename ')'",
"unary_expr : REALPART cast_expr",
"unary_expr : IMAGPART cast_expr",
"upc_blocksizeof : UPC_BLOCKSIZEOF",
"upc_localsizeof : UPC_LOCALSIZEOF",
"upc_elemsizeof : UPC_ELEMSIZEOF",
"bupc_assert_type : BUPC_ASSERT_TYPE",
"sizeof : SIZEOF",
"alignof : ALIGNOF",
"cast_expr : unary_expr",
"cast_expr : '(' typename ')' cast_expr",
"$$9 :",
"cast_expr : '(' typename ')' '{' $$9 initlist_maybe_comma '}'",
"expr_no_commas : cast_expr",
"expr_no_commas : expr_no_commas '+' expr_no_commas",
"expr_no_commas : expr_no_commas '-' expr_no_commas",
"expr_no_commas : expr_no_commas '*' expr_no_commas",
"expr_no_commas : expr_no_commas '/' expr_no_commas",
"expr_no_commas : expr_no_commas '%' expr_no_commas",
"expr_no_commas : expr_no_commas LSHIFT expr_no_commas",
"expr_no_commas : expr_no_commas RSHIFT expr_no_commas",
"expr_no_commas : expr_no_commas ARITHCOMPARE expr_no_commas",
"expr_no_commas : expr_no_commas EQCOMPARE expr_no_commas",
"expr_no_commas : expr_no_commas '&' expr_no_commas",
"expr_no_commas : expr_no_commas '|' expr_no_commas",
"expr_no_commas : expr_no_commas '^' expr_no_commas",
"$$10 :",
"expr_no_commas : expr_no_commas ANDAND $$10 expr_no_commas",
"$$11 :",
"expr_no_commas : expr_no_commas OROR $$11 expr_no_commas",
"$$12 :",
"$$13 :",
"expr_no_commas : expr_no_commas '?' $$12 expr ':' $$13 expr_no_commas",
"$$14 :",
"expr_no_commas : expr_no_commas '?' $$14 ':' expr_no_commas",
"expr_no_commas : expr_no_commas '=' expr_no_commas",
"expr_no_commas : expr_no_commas ASSIGN expr_no_commas",
"primary : IDENTIFIER",
"primary : CONSTANT",
"primary : string",
"primary : '(' expr ')'",
"primary : '(' error ')'",
"$$15 :",
"primary : '(' $$15 compstmt ')'",
"primary : bupc_assert_type '(' typename ',' typename ')'",
"primary : bupc_assert_type '(' typename ',' unary_expr ')'",
"primary : bupc_assert_type '(' unary_expr ',' typename ')'",
"primary : bupc_assert_type '(' unary_expr ',' unary_expr ')'",
"primary : primary '(' exprlist ')'",
"primary : primary '[' expr ']'",
"primary : primary '.' identifier",
"primary : primary POINTSAT identifier",
"primary : primary PLUSPLUS",
"primary : primary MINUSMINUS",
"string : STRING",
"string : string STRING",
"old_style_parm_decls :",
"old_style_parm_decls : datadecls",
"old_style_parm_decls : datadecls ELLIPSIS",
"lineno_datadecl : save_filename save_lineno datadecl",
"datadecls : lineno_datadecl",
"datadecls : errstmt",
"datadecls : datadecls lineno_datadecl",
"datadecls : lineno_datadecl errstmt",
"datadecl : typed_declspecs_no_prefix_attr setspecs initdecls ';'",
"datadecl : declmods_no_prefix_attr setspecs notype_initdecls ';'",
"datadecl : typed_declspecs_no_prefix_attr ';'",
"datadecl : declmods_no_prefix_attr ';'",
"setspecs :",
"setattrs :",
"decl : typed_declspecs setspecs initdecls ';'",
"decl : declmods setspecs notype_initdecls ';'",
"decl : typed_declspecs setspecs nested_function",
"decl : declmods setspecs notype_nested_function",
"decl : typed_declspecs ';'",
"decl : declmods ';'",
"decl : extension decl",
"typed_declspecs : typespec reserved_declspecs",
"typed_declspecs : declmods typespec reserved_declspecs",
"reserved_declspecs :",
"reserved_declspecs : reserved_declspecs typespecqual_reserved",
"reserved_declspecs : reserved_declspecs SCSPEC",
"reserved_declspecs : reserved_declspecs attributes",
"typed_declspecs_no_prefix_attr : typespec reserved_declspecs_no_prefix_attr",
"typed_declspecs_no_prefix_attr : declmods_no_prefix_attr typespec reserved_declspecs_no_prefix_attr",
"reserved_declspecs_no_prefix_attr :",
"reserved_declspecs_no_prefix_attr : reserved_declspecs_no_prefix_attr typespecqual_reserved",
"reserved_declspecs_no_prefix_attr : reserved_declspecs_no_prefix_attr SCSPEC",
"declmods : declmods_no_prefix_attr",
"declmods : attributes",
"declmods : declmods declmods_no_prefix_attr",
"declmods : declmods attributes",
"declmods_no_prefix_attr : type_qualifier",
"declmods_no_prefix_attr : SCSPEC",
"declmods_no_prefix_attr : declmods_no_prefix_attr type_qualifier",
"declmods_no_prefix_attr : declmods_no_prefix_attr SCSPEC",
"type_qualifier : TYPE_QUAL",
"type_qualifier : TYPE_QUAL_S",
"type_qualifier : TYPE_QUAL_S layout_specifier",
"typed_typespecs : typespec reserved_typespecquals",
"typed_typespecs : nonempty_type_quals typespec reserved_typespecquals",
"layout_specifier : '[' xexpr ']'",
"reserved_typespecquals :",
"reserved_typespecquals : reserved_typespecquals typespecqual_reserved",
"typespec : TYPESPEC",
"typespec : structsp",
"typespec : TYPENAME",
"typespec : TYPEOF '(' expr ')'",
"typespec : TYPEOF '(' typename ')'",
"typespecqual_reserved : TYPESPEC",
"typespecqual_reserved : TYPE_QUAL",
"typespecqual_reserved : TYPE_QUAL_S",
"typespecqual_reserved : TYPE_QUAL_S layout_specifier",
"typespecqual_reserved : structsp",
"initdecls : initdcl",
"initdecls : initdecls ',' initdcl",
"notype_initdecls : notype_initdcl",
"notype_initdecls : notype_initdecls ',' initdcl",
"maybeasm :",
"maybeasm : ASM_KEYWORD '(' string ')'",
"$$16 :",
"initdcl : declarator maybeasm maybe_attribute '=' $$16 init",
"initdcl : declarator maybeasm maybe_attribute",
"$$17 :",
"notype_initdcl : notype_declarator maybeasm maybe_attribute '=' $$17 init",
"notype_initdcl : notype_declarator maybeasm maybe_attribute",
"maybe_attribute :",
"maybe_attribute : attributes",
"attributes : attribute",
"attributes : attributes attribute",
"attribute : ATTRIBUTE '(' '(' attribute_list ')' ')'",
"attribute_list : attrib",
"attribute_list : attribute_list ',' attrib",
"attrib :",
"attrib : any_word",
"attrib : any_word '(' IDENTIFIER ')'",
"attrib : any_word '(' IDENTIFIER ',' nonnull_exprlist ')'",
"attrib : any_word '(' exprlist ')'",
"any_word : identifier",
"any_word : SCSPEC",
"any_word : TYPESPEC",
"any_word : TYPE_QUAL",
"any_word : TYPE_QUAL_S",
"init : expr_no_commas",
"$$18 :",
"init : '{' $$18 initlist_maybe_comma '}'",
"init : error",
"initlist_maybe_comma :",
"initlist_maybe_comma : initlist1 maybecomma",
"initlist1 : initelt",
"initlist1 : initlist1 ',' initelt",
"initelt : designator_list '=' initval",
"initelt : designator initval",
"$$19 :",
"initelt : identifier ':' $$19 initval",
"initelt : initval",
"$$20 :",
"initval : '{' $$20 initlist_maybe_comma '}'",
"initval : expr_no_commas",
"initval : error",
"designator_list : designator",
"designator_list : designator_list designator",
"designator : '.' identifier",
"designator : '[' expr_no_commas ELLIPSIS expr_no_commas ']'",
"designator : '[' expr_no_commas ']'",
"$$21 :",
"$$22 :",
"nested_function : declarator $$21 old_style_parm_decls $$22 compstmt",
"$$23 :",
"$$24 :",
"notype_nested_function : notype_declarator $$23 old_style_parm_decls $$24 compstmt",
"declarator : after_type_declarator",
"declarator : notype_declarator",
"after_type_declarator : '(' after_type_declarator ')'",
"after_type_declarator : after_type_declarator '(' parmlist_or_identifiers",
"after_type_declarator : after_type_declarator '[' expr ']'",
"after_type_declarator : after_type_declarator '[' ']'",
"after_type_declarator : '*' type_quals after_type_declarator",
"after_type_declarator : attributes setattrs after_type_declarator",
"after_type_declarator : TYPENAME",
"parm_declarator : parm_declarator '(' parmlist_or_identifiers",
"parm_declarator : parm_declarator '[' '*' ']'",
"parm_declarator : parm_declarator '[' expr ']'",
"parm_declarator : parm_declarator '[' ']'",
"parm_declarator : '*' type_quals parm_declarator",
"parm_declarator : attributes setattrs parm_declarator",
"parm_declarator : TYPENAME",
"notype_declarator : notype_declarator '(' parmlist_or_identifiers",
"notype_declarator : '(' notype_declarator ')'",
"notype_declarator : '*' type_quals notype_declarator",
"notype_declarator : notype_declarator '[' '*' ']'",
"notype_declarator : notype_declarator '[' expr ']'",
"notype_declarator : notype_declarator '[' ']'",
"notype_declarator : attributes setattrs notype_declarator",
"notype_declarator : IDENTIFIER",
"struct_head : STRUCT",
"struct_head : STRUCT attributes",
"union_head : UNION",
"union_head : UNION attributes",
"enum_head : ENUM",
"enum_head : ENUM attributes",
"$$25 :",
"structsp : struct_head identifier '{' $$25 component_decl_list '}' maybe_attribute",
"structsp : struct_head '{' component_decl_list '}' maybe_attribute",
"structsp : struct_head identifier",
"$$26 :",
"structsp : union_head identifier '{' $$26 component_decl_list '}' maybe_attribute",
"structsp : union_head '{' component_decl_list '}' maybe_attribute",
"structsp : union_head identifier",
"$$27 :",
"structsp : enum_head identifier '{' $$27 enumlist maybecomma_warn '}' maybe_attribute",
"$$28 :",
"structsp : enum_head '{' $$28 enumlist maybecomma_warn '}' maybe_attribute",
"structsp : enum_head identifier",
"maybecomma :",
"maybecomma : ','",
"maybecomma_warn :",
"maybecomma_warn : ','",
"component_decl_list : component_decl_list2",
"component_decl_list : component_decl_list2 component_decl",
"component_decl_list2 :",
"component_decl_list2 : component_decl_list2 component_decl ';'",
"component_decl_list2 : component_decl_list2 ';'",
"component_decl : typed_typespecs setspecs components",
"component_decl : typed_typespecs",
"component_decl : nonempty_type_quals setspecs components",
"component_decl : nonempty_type_quals",
"component_decl : error",
"component_decl : extension component_decl",
"components : component_declarator",
"components : components ',' component_declarator",
"component_declarator : save_filename save_lineno declarator maybe_attribute",
"component_declarator : save_filename save_lineno declarator ':' expr_no_commas maybe_attribute",
"component_declarator : save_filename save_lineno ':' expr_no_commas maybe_attribute",
"enumlist : enumerator",
"enumlist : enumlist ',' enumerator",
"enumlist : error",
"enumerator : identifier",
"enumerator : identifier '=' expr_no_commas",
"typename : typed_typespecs absdcl",
"typename : nonempty_type_quals absdcl",
"absdcl :",
"absdcl : absdcl1",
"nonempty_type_quals : type_qualifier",
"nonempty_type_quals : nonempty_type_quals type_qualifier",
"type_quals :",
"type_quals : type_quals type_qualifier",
"absdcl1 : '(' absdcl1 ')'",
"absdcl1 : '*' type_quals absdcl1",
"absdcl1 : '*' type_quals",
"absdcl1 : absdcl1 '(' parmlist",
"absdcl1 : absdcl1 '[' expr ']'",
"absdcl1 : absdcl1 '[' ']'",
"absdcl1 : '(' parmlist",
"absdcl1 : '[' expr ']'",
"absdcl1 : '[' ']'",
"absdcl1 : attributes setattrs absdcl1",
"stmts : lineno_stmt_or_labels",
"lineno_stmt_or_labels : lineno_stmt_or_label",
"lineno_stmt_or_labels : lineno_stmt_or_labels lineno_stmt_or_label",
"lineno_stmt_or_labels : lineno_stmt_or_labels errstmt",
"errstmt : error ';'",
"pushlevel :",
"maybe_label_decls :",
"maybe_label_decls : label_decls",
"label_decls : label_decl",
"label_decls : label_decls label_decl",
"label_decl : LABEL identifiers_or_typenames ';'",
"compstmt_or_error : compstmt",
"compstmt_or_error : error compstmt",
"compstmt_start : '{'",
"compstmt : compstmt_start '}'",
"compstmt : compstmt_start pushlevel maybe_label_decls error '}'",
"compstmt : compstmt_start pushlevel maybe_label_decls stmts '}'",
"simple_if : if_prefix lineno_labeled_stmt",
"simple_if : if_prefix error",
"if_prefix : IF '(' expr ')'",
"$$29 :",
"do_stmt_start : DO $$29 lineno_labeled_stmt WHILE",
"save_filename :",
"save_lineno :",
"lineno_labeled_stmt : save_filename save_lineno stmt",
"lineno_labeled_stmt : save_filename save_lineno label lineno_labeled_stmt",
"lineno_stmt_or_label : save_filename save_lineno stmt_or_label",
"stmt_or_label : stmt",
"stmt_or_label : label",
"stmt_or_label : decl",
"stmt : compstmt",
"stmt : all_iter_stmt",
"stmt : expr ';'",
"$$30 :",
"stmt : simple_if ELSE $$30 lineno_labeled_stmt",
"stmt : simple_if",
"stmt : simple_if ELSE error",
"$$31 :",
"$$32 :",
"stmt : WHILE $$31 '(' expr ')' $$32 lineno_labeled_stmt",
"stmt : do_stmt_start '(' expr ')' ';'",
"stmt : do_stmt_start error",
"$$33 :",
"$$34 :",
"$$35 :",
"stmt : FOR '(' for_init_stmt $$33 xexpr ';' $$34 xexpr ')' $$35 lineno_labeled_stmt",
"$$36 :",
"$$37 :",
"$$38 :",
"$$39 :",
"stmt : FORALL '(' for_init_stmt $$36 xexpr ';' $$37 xexpr ';' $$38 affinity_expr ')' $$39 lineno_labeled_stmt",
"$$40 :",
"stmt : SWITCH '(' expr ')' $$40 lineno_labeled_stmt",
"stmt : BREAK ';'",
"stmt : CONTINUE ';'",
"stmt : RETURN ';'",
"stmt : RETURN expr ';'",
"stmt : UPC_NOTIFY ';'",
"stmt : UPC_FENCE ';'",
"stmt : UPC_NOTIFY expr ';'",
"stmt : UPC_WAIT ';'",
"stmt : UPC_WAIT expr ';'",
"stmt : UPC_BARRIER ';'",
"stmt : UPC_BARRIER expr ';'",
"stmt : ASM_KEYWORD maybe_type_qual '(' expr ')' ';'",
"stmt : ASM_KEYWORD maybe_type_qual '(' expr ':' asm_operands ')' ';'",
"stmt : ASM_KEYWORD maybe_type_qual '(' expr ':' asm_operands ':' asm_operands ')' ';'",
"stmt : ASM_KEYWORD maybe_type_qual '(' expr ':' asm_operands ':' asm_operands ':' asm_clobbers ')' ';'",
"stmt : GOTO identifier ';'",
"stmt : GOTO '*' expr ';'",
"stmt : ';'",
"for_pushlevel :",
"for_init_stmt : xexpr ';'",
"for_init_stmt : for_pushlevel lineno_datadecl",
"affinity_expr : xexpr",
"affinity_expr : CONTINUE",
"all_iter_stmt : all_iter_stmt_simple",
"$$41 :",
"all_iter_stmt_simple : FOR '(' primary ')' $$41 lineno_labeled_stmt",
"label : CASE expr_no_commas ':'",
"label : CASE expr_no_commas ELLIPSIS expr_no_commas ':'",
"label : DEFAULT ':'",
"label : identifier ':' maybe_attribute",
"maybe_type_qual :",
"maybe_type_qual : TYPE_QUAL",
"xexpr :",
"xexpr : expr",
"xexpr : '*'",
"asm_operands :",
"asm_operands : nonnull_asm_operands",
"nonnull_asm_operands : asm_operand",
"nonnull_asm_operands : nonnull_asm_operands ',' asm_operand",
"asm_operand : STRING '(' expr ')'",
"asm_clobbers : string",
"asm_clobbers : asm_clobbers ',' string",
"$$42 :",
"parmlist : $$42 parmlist_1",
"parmlist_1 : parmlist_2 ')'",
"$$43 :",
"parmlist_1 : parms ';' $$43 parmlist_1",
"parmlist_1 : error ')'",
"parmlist_2 :",
"parmlist_2 : ELLIPSIS",
"parmlist_2 : parms",
"parmlist_2 : parms ',' ELLIPSIS",
"parms : parm",
"parms : parms ',' parm",
"parm : typed_declspecs setspecs parm_declarator maybe_attribute",
"parm : typed_declspecs setspecs notype_declarator maybe_attribute",
"parm : typed_declspecs setspecs absdcl maybe_attribute",
"parm : declmods setspecs notype_declarator maybe_attribute",
"parm : declmods setspecs absdcl maybe_attribute",
"$$44 :",
"parmlist_or_identifiers : $$44 parmlist_or_identifiers_1",
"parmlist_or_identifiers_1 : parmlist_1",
"parmlist_or_identifiers_1 : identifiers ')'",
"identifiers : IDENTIFIER",
"identifiers : identifiers ',' IDENTIFIER",
"identifiers_or_typenames : identifier",
"identifiers_or_typenames : identifiers_or_typenames ',' identifier",
"extension : EXTENSION",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 276 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids an empty source file");
		  finish_file ();
		}
break;
case 2:
#line 281 "c-parse.y"
{
		  /* In case there were missing closebraces,
		     get us back to the global binding level.  */
		  while (! global_bindings_p ())
		    poplevel (0, 0, 0);
		  finish_file ();
		}
break;
case 3:
#line 295 "c-parse.y"
{yyval.ttype = NULL_TREE; }
break;
case 5:
#line 296 "c-parse.y"
{yyval.ttype = NULL_TREE; }
break;
case 9:
#line 303 "c-parse.y"
{ STRIP_NOPS (yyvsp[-2].ttype);
		  if ((TREE_CODE (yyvsp[-2].ttype) == ADDR_EXPR
		       && TREE_CODE (TREE_OPERAND (yyvsp[-2].ttype, 0)) == STRING_CST)
		      || TREE_CODE (yyvsp[-2].ttype) == STRING_CST)
		    assemble_asm (yyvsp[-2].ttype);
		  else
		    error ("argument of `asm' is not a constant string"); }
break;
case 10:
#line 311 "c-parse.y"
{ pedantic = yyvsp[-1].itype; }
break;
case 11:
#line 316 "c-parse.y"
{ if (pedantic)
		    error ("ANSI C forbids data definition with no type or storage class");
		  else if (!flag_traditional)
		    warning ("data definition has no type or storage class"); 

		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 12:
#line 326 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 13:
#line 331 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype);  }
break;
case 14:
#line 336 "c-parse.y"
{ pedwarn ("empty declaration"); }
break;
case 15:
#line 338 "c-parse.y"
{ shadow_tag (yyvsp[-1].ttype); }
break;
case 18:
#line 342 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C does not allow extra `;' outside of a function"); }
break;
case 19:
#line 348 "c-parse.y"
{ if (! start_function (current_declspecs, yyvsp[0].ttype,
					prefix_attributes, NULL_TREE))
		    YYERROR1;
		  reinit_parse_for_function (); }
break;
case 20:
#line 353 "c-parse.y"
{ store_parm_decls (); }
break;
case 21:
#line 355 "c-parse.y"
{ finish_function (0); 
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-5].itype); }
break;
case 22:
#line 361 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 23:
#line 366 "c-parse.y"
{ if (! start_function (current_declspecs, yyvsp[0].ttype,
					prefix_attributes, NULL_TREE))
		    YYERROR1;
		  reinit_parse_for_function (); }
break;
case 24:
#line 371 "c-parse.y"
{ store_parm_decls (); }
break;
case 25:
#line 373 "c-parse.y"
{ finish_function (0); 
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-5].itype); }
break;
case 26:
#line 379 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 27:
#line 384 "c-parse.y"
{ if (! start_function (NULL_TREE, yyvsp[0].ttype,
					prefix_attributes, NULL_TREE))
		    YYERROR1;
		  reinit_parse_for_function (); }
break;
case 28:
#line 389 "c-parse.y"
{ store_parm_decls (); }
break;
case 29:
#line 391 "c-parse.y"
{ finish_function (0); 
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-5].itype); }
break;
case 30:
#line 397 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 33:
#line 409 "c-parse.y"
{ yyval.code = ADDR_EXPR; }
break;
case 34:
#line 411 "c-parse.y"
{ yyval.code = NEGATE_EXPR; }
break;
case 35:
#line 413 "c-parse.y"
{ yyval.code = CONVERT_EXPR; }
break;
case 36:
#line 415 "c-parse.y"
{ yyval.code = PREINCREMENT_EXPR; }
break;
case 37:
#line 417 "c-parse.y"
{ yyval.code = PREDECREMENT_EXPR; }
break;
case 38:
#line 419 "c-parse.y"
{ yyval.code = BIT_NOT_EXPR; }
break;
case 39:
#line 421 "c-parse.y"
{ yyval.code = TRUTH_NOT_EXPR; }
break;
case 40:
#line 425 "c-parse.y"
{ yyval.ttype = build_compound_expr (yyvsp[0].ttype); }
break;
case 41:
#line 430 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 43:
#line 436 "c-parse.y"
{ yyval.ttype = build_tree_list (NULL_TREE, yyvsp[0].ttype); }
break;
case 44:
#line 438 "c-parse.y"
{ chainon (yyvsp[-2].ttype, build_tree_list (NULL_TREE, yyvsp[0].ttype)); }
break;
case 46:
#line 444 "c-parse.y"
{ yyval.ttype = build_indirect_ref (yyvsp[0].ttype, "unary *"); }
break;
case 47:
#line 447 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  pedantic = yyvsp[-1].itype; }
break;
case 48:
#line 450 "c-parse.y"
{ yyval.ttype = build_unary_op (yyvsp[-1].code, yyvsp[0].ttype, 0);
		  overflow_warning (yyval.ttype); }
break;
case 49:
#line 454 "c-parse.y"
{ tree label = lookup_label (yyvsp[0].ttype);
		  if (pedantic)
		    pedwarn ("ANSI C forbids `&&'");
		  if (label == 0)
		    yyval.ttype = null_pointer_node;
		  else
		    {
		      TREE_USED (label) = 1;
		      yyval.ttype = build1 (ADDR_EXPR, ptr_type_node, label);
		      TREE_CONSTANT (yyval.ttype) = 1;
		    }
		}
break;
case 50:
#line 482 "c-parse.y"
{ skip_evaluation--;
		  if (TREE_CODE (yyvsp[0].ttype) == COMPONENT_REF
		      && DECL_C_BIT_FIELD (TREE_OPERAND (yyvsp[0].ttype, 1)))
		    error ("`sizeof' applied to a bit-field");
		  yyval.ttype = c_sizeof (TREE_TYPE (yyvsp[0].ttype)); }
break;
case 51:
#line 488 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = c_sizeof (groktypename (yyvsp[-1].ttype)); }
break;
case 52:
#line 492 "c-parse.y"
{ skip_evaluation--;
		  if (TREE_CODE (yyvsp[0].ttype) == COMPONENT_REF
		      && DECL_C_BIT_FIELD (TREE_OPERAND (yyvsp[0].ttype, 1)))
		    error ("`upc_blocksizeof' applied to a bit-field");
		  if (TREE_CODE (yyvsp[0].ttype) == ADDR_EXPR && 
		      TREE_CODE(TREE_OPERAND(yyvsp[0].ttype, 0)) == COMPONENT_REF) {
		    tree field_struct = TREE_OPERAND(TREE_OPERAND(yyvsp[0].ttype, 0), 0);
		    if (TYPE_SHARED(TREE_TYPE(field_struct))) {
		      yyval.ttype = integer_zero_node;
		    } else {
		      yyval.ttype = upc_blocksizeof(yyvsp[0].ttype);
		    }
		  } else {
		    yyval.ttype = upc_blocksizeof(yyvsp[0].ttype); 
		  }
		}
break;
case 53:
#line 509 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = upc_blocksizeof (groktypename (yyvsp[-1].ttype)); }
break;
case 54:
#line 512 "c-parse.y"
{ skip_evaluation--;
		  if (TREE_CODE (yyvsp[0].ttype) == COMPONENT_REF
		      && DECL_C_BIT_FIELD (TREE_OPERAND (yyvsp[0].ttype, 1)))
		    error ("`upc_localsizeof' applied to a bit-field");
		  yyval.ttype = upc_localsizeof (yyvsp[0].ttype); }
break;
case 55:
#line 518 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = upc_localsizeof (groktypename (yyvsp[-1].ttype)); }
break;
case 56:
#line 521 "c-parse.y"
{ skip_evaluation--;
		  if (TREE_CODE (yyvsp[0].ttype) == COMPONENT_REF
		      && DECL_C_BIT_FIELD (TREE_OPERAND (yyvsp[0].ttype, 1)))
		    error ("`upc_elemsizeof' applied to a bit-field");
		  yyval.ttype = upc_elemsizeof (TREE_TYPE (yyvsp[0].ttype)); }
break;
case 57:
#line 527 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = upc_elemsizeof (groktypename (yyvsp[-1].ttype)); }
break;
case 58:
#line 530 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = c_alignof_expr (yyvsp[0].ttype); }
break;
case 59:
#line 533 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = c_alignof (groktypename (yyvsp[-1].ttype)); }
break;
case 60:
#line 536 "c-parse.y"
{ yyval.ttype = build_unary_op (REALPART_EXPR, yyvsp[0].ttype, 0); }
break;
case 61:
#line 538 "c-parse.y"
{ yyval.ttype = build_unary_op (IMAGPART_EXPR, yyvsp[0].ttype, 0); }
break;
case 62:
#line 543 "c-parse.y"
{ skip_evaluation++; }
break;
case 63:
#line 546 "c-parse.y"
{ skip_evaluation++; }
break;
case 64:
#line 549 "c-parse.y"
{ skip_evaluation++; }
break;
case 65:
#line 552 "c-parse.y"
{skip_evaluation++; }
break;
case 66:
#line 555 "c-parse.y"
{ skip_evaluation++; }
break;
case 67:
#line 560 "c-parse.y"
{ skip_evaluation++; }
break;
case 69:
#line 566 "c-parse.y"
{ tree type = groktypename (yyvsp[-2].ttype);
		  yyval.ttype = build_c_cast (type, yyvsp[0].ttype); }
break;
case 70:
#line 569 "c-parse.y"
{ start_init (NULL_TREE, NULL, 0);
		  yyvsp[-2].ttype = groktypename (yyvsp[-2].ttype);
		  really_start_incremental_init (yyvsp[-2].ttype); }
break;
case 71:
#line 573 "c-parse.y"
{ char *name;
		  tree result = pop_init_level (0);
		  tree type = yyvsp[-5].ttype;
		  finish_init ();

		  if (pedantic && ! flag_isoc99)
		    pedwarn ("ANSI C forbids constructor expressions");
		  if (TYPE_NAME (type) != 0)
		    {
		      if (TREE_CODE (TYPE_NAME (type)) == IDENTIFIER_NODE)
			name = IDENTIFIER_POINTER (TYPE_NAME (type));
		      else
			name = IDENTIFIER_POINTER (DECL_NAME (TYPE_NAME (type)));
		    }
		  else
		    name = "";
		  yyval.ttype = result;
		  if (TREE_CODE (type) == ARRAY_TYPE && TYPE_SIZE (type) == 0)
		    {
		      int failure = complete_array_type (type, yyval.ttype, 1);
		      if (failure)
			abort ();
		    }
		}
break;
case 73:
#line 602 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 74:
#line 604 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 75:
#line 606 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 76:
#line 608 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 77:
#line 610 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 78:
#line 612 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 79:
#line 614 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 80:
#line 616 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 81:
#line 618 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 82:
#line 620 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 83:
#line 622 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 84:
#line 624 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 85:
#line 626 "c-parse.y"
{ yyvsp[-1].ttype = truthvalue_conversion (default_conversion (yyvsp[-1].ttype));
		  skip_evaluation += yyvsp[-1].ttype == boolean_false_node; }
break;
case 86:
#line 629 "c-parse.y"
{ skip_evaluation -= yyvsp[-3].ttype == boolean_false_node;
		  yyval.ttype = parser_build_binary_op (TRUTH_ANDIF_EXPR, yyvsp[-3].ttype, yyvsp[0].ttype); }
break;
case 87:
#line 632 "c-parse.y"
{ yyvsp[-1].ttype = truthvalue_conversion (default_conversion (yyvsp[-1].ttype));
		  skip_evaluation += yyvsp[-1].ttype == boolean_true_node; }
break;
case 88:
#line 635 "c-parse.y"
{ skip_evaluation -= yyvsp[-3].ttype == boolean_true_node;
		  yyval.ttype = parser_build_binary_op (TRUTH_ORIF_EXPR, yyvsp[-3].ttype, yyvsp[0].ttype); }
break;
case 89:
#line 638 "c-parse.y"
{ yyvsp[-1].ttype = truthvalue_conversion (default_conversion (yyvsp[-1].ttype));
		  skip_evaluation += yyvsp[-1].ttype == boolean_false_node; }
break;
case 90:
#line 641 "c-parse.y"
{ skip_evaluation += ((yyvsp[-4].ttype == boolean_true_node)
				      - (yyvsp[-4].ttype == boolean_false_node)); }
break;
case 91:
#line 644 "c-parse.y"
{ skip_evaluation -= yyvsp[-6].ttype == boolean_true_node;
		  yyval.ttype = build_conditional_expr (yyvsp[-6].ttype, yyvsp[-3].ttype, yyvsp[0].ttype); }
break;
case 92:
#line 647 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids omitting the middle term of a ?: expression");
		  /* Make sure first operand is calculated only once.  */
		  yyvsp[0].ttype = save_expr (yyvsp[-1].ttype);
		  yyvsp[-1].ttype = truthvalue_conversion (default_conversion (yyvsp[0].ttype));
		  skip_evaluation += yyvsp[-1].ttype == boolean_true_node; }
break;
case 93:
#line 654 "c-parse.y"
{ skip_evaluation -= yyvsp[-4].ttype == boolean_true_node;
		  yyval.ttype = build_conditional_expr (yyvsp[-4].ttype, yyvsp[-3].ttype, yyvsp[0].ttype); }
break;
case 94:
#line 657 "c-parse.y"
{ char class;
		  yyval.ttype = build_modify_expr (yyvsp[-2].ttype, NOP_EXPR, yyvsp[0].ttype);
		  class = TREE_CODE_CLASS (TREE_CODE (yyval.ttype));
		  if (class == 'e' || class == '1'
		      || class == '2' || class == '<')
		    C_SET_EXP_ORIGINAL_CODE (yyval.ttype, MODIFY_EXPR);
		}
break;
case 95:
#line 665 "c-parse.y"
{ char class;
		  yyval.ttype = build_modify_expr (yyvsp[-2].ttype, yyvsp[-1].code, yyvsp[0].ttype);
		  /* This inhibits warnings in truthvalue_conversion.  */
		  class = TREE_CODE_CLASS (TREE_CODE (yyval.ttype));
		  if (class == 'e' || class == '1'
		      || class == '2' || class == '<')
		    C_SET_EXP_ORIGINAL_CODE (yyval.ttype, ERROR_MARK);
		}
break;
case 96:
#line 677 "c-parse.y"
{
		  yyval.ttype = lastiddecl;
		  if (!yyval.ttype || yyval.ttype == error_mark_node)
		    {
		      if (yychar == YYEMPTY)
			yychar = YYLEX;
		      if (yychar == '(')
			{
			    {
			      /* Ordinary implicit function declaration.  */
			      yyval.ttype = implicitly_declare (yyvsp[0].ttype);
			      assemble_external (yyval.ttype);
			      TREE_USED (yyval.ttype) = 1;
			    }
			}
		      else if (current_function_decl == 0)
			{
			  error ("`%s' undeclared here (not in a function)",
				 IDENTIFIER_POINTER (yyvsp[0].ttype));
			  yyval.ttype = error_mark_node;
			}
		      else
			{
			    {
			      if (IDENTIFIER_GLOBAL_VALUE (yyvsp[0].ttype) != error_mark_node
				  || IDENTIFIER_ERROR_LOCUS (yyvsp[0].ttype) != current_function_decl)
				{
				  error ("`%s' undeclared (first use in this function)",
					 IDENTIFIER_POINTER (yyvsp[0].ttype));

				  if (! undeclared_variable_notice)
				    {
				      error ("(Each undeclared identifier is reported only once");
				      error ("for each function it appears in.)");
				      undeclared_variable_notice = 1;
				    }
				}
			      yyval.ttype = error_mark_node;
			      /* Prevent repeated error messages.  */
			      IDENTIFIER_GLOBAL_VALUE (yyvsp[0].ttype) = error_mark_node;
			      IDENTIFIER_ERROR_LOCUS (yyvsp[0].ttype) = current_function_decl;
			    }
			}
		    }
		  else if (TREE_TYPE (yyval.ttype) == error_mark_node)
		    yyval.ttype = error_mark_node;
		  else if (C_DECL_ANTICIPATED (yyval.ttype))
		    {
		      /* The first time we see a build-in function used,
			 if it has not been declared.  */
		      C_DECL_ANTICIPATED (yyval.ttype) = 0;
		      if (yychar == YYEMPTY)
			yychar = YYLEX;
		      if (yychar == '(')
			{
			  /* Omit the implicit declaration we
			     would ordinarily do, so we don't lose
			     the actual built in type.
			     But print a diagnostic for the mismatch.  */
			    if (TREE_CODE (yyval.ttype) != FUNCTION_DECL)
			      error ("`%s' implicitly declared as function",
				     IDENTIFIER_POINTER (DECL_NAME (yyval.ttype)));
			  else if ((TYPE_MODE (TREE_TYPE (TREE_TYPE (yyval.ttype)))
				    != TYPE_MODE (integer_type_node))
				   && (TREE_TYPE (TREE_TYPE (yyval.ttype))
				       != void_type_node))
			    pedwarn ("type mismatch in implicit declaration for built-in function `%s'",
				     IDENTIFIER_POINTER (DECL_NAME (yyval.ttype)));
			  /* If it really returns void, change that to int.  */
			  if (TREE_TYPE (TREE_TYPE (yyval.ttype)) == void_type_node)
			    TREE_TYPE (yyval.ttype)
			      = build_function_type (integer_type_node,
						     TYPE_ARG_TYPES (TREE_TYPE (yyval.ttype)));
			}
		      else
			pedwarn ("built-in function `%s' used without declaration",
				 IDENTIFIER_POINTER (DECL_NAME (yyval.ttype)));

		      /* Do what we would ordinarily do when a fn is used.  */
		      assemble_external (yyval.ttype);
		      TREE_USED (yyval.ttype) = 1;
		    }
		  else
		    {
		      assemble_external (yyval.ttype);
		      TREE_USED (yyval.ttype) = 1;
		    }

		  if (TREE_CODE (yyval.ttype) == CONST_DECL)
		    {
		      yyval.ttype = DECL_INITIAL (yyval.ttype);
		      /* This is to prevent an enum whose value is 0
			 from being considered a null pointer constant.  */
		      yyval.ttype = build1 (NOP_EXPR, TREE_TYPE (yyval.ttype), yyval.ttype);
		      TREE_CONSTANT (yyval.ttype) = 1;
		    }
		}
break;
case 98:
#line 776 "c-parse.y"
{ yyval.ttype = combine_strings (yyvsp[0].ttype); }
break;
case 99:
#line 778 "c-parse.y"
{ char class = TREE_CODE_CLASS (TREE_CODE (yyvsp[-1].ttype));
		  if (class == 'e' || class == '1'
		      || class == '2' || class == '<')
		    C_SET_EXP_ORIGINAL_CODE (yyvsp[-1].ttype, ERROR_MARK);
		  yyval.ttype = yyvsp[-1].ttype; }
break;
case 100:
#line 784 "c-parse.y"
{ yyval.ttype = error_mark_node; }
break;
case 101:
#line 786 "c-parse.y"
{ if (current_function_decl == 0)
		    {
		      error ("braced-group within expression allowed only inside a function");
		      YYERROR;
		    }
		  /* We must force a BLOCK for this level
		     so that, if it is not expanded later,
		     there is a way to turn off the entire subtree of blocks
		     that are contained in it.  */
		  keep_next_level ();
		  push_iterator_stack ();
		  push_label_level ();
		  yyval.ttype = expand_start_stmt_expr (); }
break;
case 102:
#line 800 "c-parse.y"
{ tree rtl_exp;
		  if (pedantic)
		    pedwarn ("ANSI C forbids braced-groups within expressions");
		  pop_iterator_stack ();
		  pop_label_level ();
		  rtl_exp = expand_end_stmt_expr (yyvsp[-2].ttype);
		  /* The statements have side effects, so the group does.  */
		  TREE_SIDE_EFFECTS (rtl_exp) = 1;

		  if (TREE_CODE (yyvsp[-1].ttype) == BLOCK)
		    {
		      /* Make a BIND_EXPR for the BLOCK already made.  */
		      yyval.ttype = build (BIND_EXPR, TREE_TYPE (rtl_exp),
				  NULL_TREE, rtl_exp, yyvsp[-1].ttype);
		      /* Remove the block from the tree at this point.
			 It gets put back at the proper place
			 when the BIND_EXPR is expanded.  */
		      delete_block (yyvsp[-1].ttype);
		    }
		  else
		    yyval.ttype = yyvsp[-1].ttype;
		}
break;
case 103:
#line 823 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = bupc_assert_type(groktypename (yyvsp[-3].ttype), groktypename (yyvsp[-1].ttype)); }
break;
case 104:
#line 826 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = bupc_assert_type(groktypename (yyvsp[-3].ttype), TREE_TYPE(yyvsp[-1].ttype)); }
break;
case 105:
#line 829 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = bupc_assert_type(TREE_TYPE (yyvsp[-3].ttype), groktypename (yyvsp[-1].ttype)); }
break;
case 106:
#line 832 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = bupc_assert_type(TREE_TYPE (yyvsp[-3].ttype), TREE_TYPE(yyvsp[-1].ttype)); }
break;
case 107:
#line 835 "c-parse.y"
{ yyval.ttype = build_function_call (yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 108:
#line 837 "c-parse.y"
{ yyval.ttype = build_array_ref (yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 109:
#line 839 "c-parse.y"
{
		    yyval.ttype = build_component_ref (yyvsp[-2].ttype, yyvsp[0].ttype);
		}
break;
case 110:
#line 843 "c-parse.y"
{
                  tree expr = build_indirect_ref (yyvsp[-2].ttype, "->");

                    yyval.ttype = build_component_ref (expr, yyvsp[0].ttype);
		}
break;
case 111:
#line 849 "c-parse.y"
{ yyval.ttype = build_unary_op (POSTINCREMENT_EXPR, yyvsp[-1].ttype, 0); }
break;
case 112:
#line 851 "c-parse.y"
{ yyval.ttype = build_unary_op (POSTDECREMENT_EXPR, yyvsp[-1].ttype, 0); }
break;
case 114:
#line 858 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 117:
#line 867 "c-parse.y"
{ c_mark_varargs ();
		  if (pedantic)
		    pedwarn ("ANSI C does not permit use of `varargs.h'"); }
break;
case 118:
#line 877 "c-parse.y"
{ }
break;
case 123:
#line 893 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 124:
#line 898 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);	
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 125:
#line 903 "c-parse.y"
{ shadow_tag_warned (yyvsp[-1].ttype, 1);
		  pedwarn ("empty declaration"); }
break;
case 126:
#line 906 "c-parse.y"
{ pedwarn ("empty declaration"); }
break;
case 127:
#line 936 "c-parse.y"
{ yyval.itype = suspend_momentary ();
		  pending_xref_error ();
		  declspec_stack = tree_cons (prefix_attributes,
					      current_declspecs,
					      declspec_stack);
		  split_specs_attrs (yyvsp[0].ttype,
				     &current_declspecs, &prefix_attributes); }
break;
case 128:
#line 947 "c-parse.y"
{ prefix_attributes = chainon (prefix_attributes, yyvsp[0].ttype); }
break;
case 129:
#line 952 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 130:
#line 957 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 131:
#line 962 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-1].itype); }
break;
case 132:
#line 967 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-1].itype); }
break;
case 133:
#line 972 "c-parse.y"
{ shadow_tag (yyvsp[-1].ttype); }
break;
case 134:
#line 974 "c-parse.y"
{ pedwarn ("empty declaration"); }
break;
case 135:
#line 976 "c-parse.y"
{ pedantic = yyvsp[-1].itype; }
break;
case 136:
#line 986 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 137:
#line 988 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[-2].ttype)); }
break;
case 138:
#line 992 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 139:
#line 994 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 140:
#line 996 "c-parse.y"
{ if (extra_warnings)
		    warning ("`%s' is not at beginning of declaration",
			     IDENTIFIER_POINTER (yyvsp[0].ttype));
		  yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 141:
#line 1001 "c-parse.y"
{ yyval.ttype = tree_cons (yyvsp[0].ttype, NULL_TREE, yyvsp[-1].ttype); }
break;
case 142:
#line 1006 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 143:
#line 1008 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[-2].ttype)); }
break;
case 144:
#line 1013 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 145:
#line 1015 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 146:
#line 1017 "c-parse.y"
{ if (extra_warnings)
		    warning ("`%s' is not at beginning of declaration",
			     IDENTIFIER_POINTER (yyvsp[0].ttype));
		  yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 147:
#line 1030 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 148:
#line 1032 "c-parse.y"
{ yyval.ttype = tree_cons (yyvsp[0].ttype, NULL_TREE, NULL_TREE); }
break;
case 149:
#line 1034 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 150:
#line 1036 "c-parse.y"
{ yyval.ttype = tree_cons (yyvsp[0].ttype, NULL_TREE, yyvsp[-1].ttype); }
break;
case 151:
#line 1041 "c-parse.y"
{ TREE_STATIC (yyval.ttype) = 1; }
break;
case 152:
#line 1043 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, NULL_TREE); }
break;
case 153:
#line 1045 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, yyvsp[-1].ttype);
		  TREE_STATIC (yyval.ttype) = 1; }
break;
case 154:
#line 1048 "c-parse.y"
{ if (extra_warnings && TREE_STATIC (yyvsp[-1].ttype))
		    warning ("`%s' is not at beginning of declaration",
			     IDENTIFIER_POINTER (yyvsp[0].ttype));
		  yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype);
		  TREE_STATIC (yyval.ttype) = TREE_STATIC (yyvsp[-1].ttype); }
break;
case 155:
#line 1057 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, NULL_TREE); }
break;
case 156:
#line 1059 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, NULL_TREE); }
break;
case 157:
#line 1061 "c-parse.y"
{ 
	  
		  yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype,
				 tree_cons (NULL_TREE, yyvsp[-1].ttype, NULL_TREE)); }
break;
case 158:
#line 1075 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 159:
#line 1077 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[-2].ttype)); }
break;
case 160:
#line 1083 "c-parse.y"
{ yyval.ttype = tree_cons(NULL_TREE, yyvsp[-1].ttype, NULL_TREE); }
break;
case 161:
#line 1086 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 162:
#line 1088 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 165:
#line 1098 "c-parse.y"
{ /* For a typedef name, record the meaning, not the name.
		     In case of `foo foo, bar;'.  */
		  yyval.ttype = lookup_name (yyvsp[0].ttype); }
break;
case 166:
#line 1102 "c-parse.y"
{ yyval.ttype = TREE_TYPE (yyvsp[-1].ttype); }
break;
case 167:
#line 1104 "c-parse.y"
{ yyval.ttype = groktypename (yyvsp[-1].ttype); }
break;
case 171:
#line 1114 "c-parse.y"
{ 
	  
  yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype,
		  tree_cons (NULL_TREE, yyvsp[-1].ttype, NULL_TREE)); }
break;
case 177:
#line 1133 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 178:
#line 1135 "c-parse.y"
{ if (TREE_CHAIN (yyvsp[-1].ttype)) yyvsp[-1].ttype = combine_strings (yyvsp[-1].ttype);
		  yyval.ttype = yyvsp[-1].ttype;
		}
break;
case 179:
#line 1142 "c-parse.y"
{ yyval.ttype = start_decl (yyvsp[-3].ttype, current_declspecs, 1,
					  yyvsp[-1].ttype, prefix_attributes);
		  start_init (yyval.ttype, yyvsp[-2].ttype, global_bindings_p ()); }
break;
case 180:
#line 1147 "c-parse.y"
{ finish_init ();
		  finish_decl (yyvsp[-1].ttype, yyvsp[0].ttype, yyvsp[-4].ttype); }
break;
case 181:
#line 1150 "c-parse.y"
{ tree d = start_decl (yyvsp[-2].ttype, current_declspecs, 0,
				       yyvsp[0].ttype, prefix_attributes);
		  finish_decl (d, NULL_TREE, yyvsp[-1].ttype); 
                }
break;
case 182:
#line 1158 "c-parse.y"
{ yyval.ttype = start_decl (yyvsp[-3].ttype, current_declspecs, 1,
					  yyvsp[-1].ttype, prefix_attributes);
		  start_init (yyval.ttype, yyvsp[-2].ttype, global_bindings_p ()); }
break;
case 183:
#line 1163 "c-parse.y"
{ finish_init ();
		  decl_attributes (yyvsp[-1].ttype, yyvsp[-3].ttype, prefix_attributes);
		  finish_decl (yyvsp[-1].ttype, yyvsp[0].ttype, yyvsp[-4].ttype); }
break;
case 184:
#line 1167 "c-parse.y"
{ tree d = start_decl (yyvsp[-2].ttype, current_declspecs, 0,
				       yyvsp[0].ttype, prefix_attributes);
		  finish_decl (d, NULL_TREE, yyvsp[-1].ttype); }
break;
case 185:
#line 1175 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 186:
#line 1177 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 187:
#line 1182 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 188:
#line 1184 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 189:
#line 1189 "c-parse.y"
{ yyval.ttype = yyvsp[-2].ttype; }
break;
case 190:
#line 1194 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 191:
#line 1196 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 192:
#line 1201 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 193:
#line 1203 "c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[0].ttype, NULL_TREE); }
break;
case 194:
#line 1205 "c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-3].ttype, build_tree_list (NULL_TREE, yyvsp[-1].ttype)); }
break;
case 195:
#line 1207 "c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-5].ttype, tree_cons (NULL_TREE, yyvsp[-3].ttype, yyvsp[-1].ttype)); }
break;
case 196:
#line 1209 "c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 203:
#line 1228 "c-parse.y"
{ really_start_incremental_init (NULL_TREE);
		  /* Note that the call to clear_momentary
		     is in process_init_element.  */
		  push_momentary (); }
break;
case 204:
#line 1233 "c-parse.y"
{ yyval.ttype = pop_init_level (0);
		  if (yyval.ttype == error_mark_node
		      && ! (yychar == STRING || yychar == CONSTANT))
		    pop_momentary ();
		  else
		    pop_momentary_nofree (); }
break;
case 205:
#line 1241 "c-parse.y"
{ yyval.ttype = error_mark_node; }
break;
case 206:
#line 1247 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids empty initializer braces"); }
break;
case 212:
#line 1263 "c-parse.y"
{ set_init_label (yyvsp[-1].ttype); }
break;
case 215:
#line 1270 "c-parse.y"
{ push_init_level (0); }
break;
case 216:
#line 1272 "c-parse.y"
{ process_init_element (pop_init_level (0)); }
break;
case 217:
#line 1274 "c-parse.y"
{ process_init_element (yyvsp[0].ttype); }
break;
case 221:
#line 1285 "c-parse.y"
{ set_init_label (yyvsp[0].ttype); }
break;
case 222:
#line 1290 "c-parse.y"
{ set_init_index (yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 223:
#line 1292 "c-parse.y"
{ set_init_index (yyvsp[-1].ttype, NULL_TREE); }
break;
case 224:
#line 1297 "c-parse.y"
{ push_function_context ();
		  if (! start_function (current_declspecs, yyvsp[0].ttype,
					prefix_attributes, NULL_TREE))
		    {
		      pop_function_context ();
		      YYERROR1;
		    }
		  reinit_parse_for_function (); }
break;
case 225:
#line 1306 "c-parse.y"
{ store_parm_decls (); }
break;
case 226:
#line 1314 "c-parse.y"
{ finish_function (1);
		  pop_function_context (); }
break;
case 227:
#line 1320 "c-parse.y"
{ push_function_context ();
		  if (! start_function (current_declspecs, yyvsp[0].ttype,
					prefix_attributes, NULL_TREE))
		    {
		      pop_function_context ();
		      YYERROR1;
		    }
		  reinit_parse_for_function (); }
break;
case 228:
#line 1329 "c-parse.y"
{ store_parm_decls (); }
break;
case 229:
#line 1337 "c-parse.y"
{ finish_function (1);
		  pop_function_context (); }
break;
case 232:
#line 1353 "c-parse.y"
{ yyval.ttype = yyvsp[-1].ttype; }
break;
case 233:
#line 1355 "c-parse.y"
{ yyval.ttype = build_nt (CALL_EXPR, yyvsp[-2].ttype, yyvsp[0].ttype, NULL_TREE); }
break;
case 234:
#line 1360 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 235:
#line 1362 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-2].ttype, NULL_TREE); }
break;
case 236:
#line 1364 "c-parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 237:
#line 1371 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 239:
#line 1382 "c-parse.y"
{ yyval.ttype = build_nt (CALL_EXPR, yyvsp[-2].ttype, yyvsp[0].ttype, NULL_TREE); }
break;
case 240:
#line 1387 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-3].ttype, NULL_TREE);
		  if (! flag_isoc99)
		    error ("`[*]' in parameter declaration only allowed in ISO C 9x");
		}
break;
case 241:
#line 1392 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 242:
#line 1394 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-2].ttype, NULL_TREE); }
break;
case 243:
#line 1396 "c-parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 244:
#line 1403 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 246:
#line 1412 "c-parse.y"
{ yyval.ttype = build_nt (CALL_EXPR, yyvsp[-2].ttype, yyvsp[0].ttype, NULL_TREE); }
break;
case 247:
#line 1417 "c-parse.y"
{ yyval.ttype = yyvsp[-1].ttype; }
break;
case 248:
#line 1419 "c-parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 249:
#line 1421 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-3].ttype, NULL_TREE);
		  if (! flag_isoc99)
		    error ("`[*]' in parameter declaration only allowed in ISO C 9x");
		}
break;
case 250:
#line 1426 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 251:
#line 1428 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-2].ttype, NULL_TREE); }
break;
case 252:
#line 1435 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 254:
#line 1441 "c-parse.y"
{ yyval.ttype = NULL_TREE; defining_type++; }
break;
case 255:
#line 1443 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; defining_type++; }
break;
case 256:
#line 1448 "c-parse.y"
{ yyval.ttype = NULL_TREE; defining_type++; }
break;
case 257:
#line 1450 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; defining_type++; }
break;
case 258:
#line 1455 "c-parse.y"
{ yyval.ttype = NULL_TREE; defining_type++; }
break;
case 259:
#line 1457 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; defining_type++; }
break;
case 260:
#line 1462 "c-parse.y"
{ yyval.ttype = start_struct (RECORD_TYPE, yyvsp[-1].ttype);
		  /* Start scope of tag before parsing components.  */
		}
break;
case 261:
#line 1466 "c-parse.y"
{ yyval.ttype = finish_struct (yyvsp[-3].ttype, yyvsp[-2].ttype, chainon (yyvsp[-6].ttype, yyvsp[0].ttype));
		  defining_type--;
		}
break;
case 262:
#line 1470 "c-parse.y"
{ yyval.ttype = finish_struct (start_struct (RECORD_TYPE, NULL_TREE),
				      yyvsp[-2].ttype, chainon (yyvsp[-4].ttype, yyvsp[0].ttype));
		  defining_type--;
		}
break;
case 263:
#line 1475 "c-parse.y"
{ yyval.ttype = xref_tag (RECORD_TYPE, yyvsp[0].ttype); defining_type--; }
break;
case 264:
#line 1477 "c-parse.y"
{ yyval.ttype = start_struct (UNION_TYPE, yyvsp[-1].ttype); }
break;
case 265:
#line 1479 "c-parse.y"
{ yyval.ttype = finish_struct (yyvsp[-3].ttype, yyvsp[-2].ttype, chainon (yyvsp[-6].ttype, yyvsp[0].ttype));
		  defining_type--;
		}
break;
case 266:
#line 1483 "c-parse.y"
{ yyval.ttype = finish_struct (start_struct (UNION_TYPE, NULL_TREE),
				      yyvsp[-2].ttype, chainon (yyvsp[-4].ttype, yyvsp[0].ttype));
		  defining_type--;
		}
break;
case 267:
#line 1488 "c-parse.y"
{ yyval.ttype = xref_tag (UNION_TYPE, yyvsp[0].ttype); defining_type--; }
break;
case 268:
#line 1490 "c-parse.y"
{ yyvsp[0].itype = suspend_momentary ();
		  yyval.ttype = start_enum (yyvsp[-1].ttype); }
break;
case 269:
#line 1493 "c-parse.y"
{ yyval.ttype= finish_enum (yyvsp[-4].ttype, nreverse (yyvsp[-3].ttype), chainon (yyvsp[-7].ttype, yyvsp[0].ttype));
		  defining_type--;
		  resume_momentary (yyvsp[-5].itype); }
break;
case 270:
#line 1497 "c-parse.y"
{ yyvsp[0].itype = suspend_momentary ();
		  yyval.ttype = start_enum (NULL_TREE); }
break;
case 271:
#line 1500 "c-parse.y"
{ yyval.ttype= finish_enum (yyvsp[-4].ttype, nreverse (yyvsp[-3].ttype), chainon (yyvsp[-6].ttype, yyvsp[0].ttype));
		  defining_type--;
		  resume_momentary (yyvsp[-5].itype); }
break;
case 272:
#line 1504 "c-parse.y"
{ yyval.ttype = xref_tag (ENUMERAL_TYPE, yyvsp[0].ttype); defining_type--; }
break;
case 276:
#line 1515 "c-parse.y"
{ if (pedantic && ! flag_isoc99)
		    pedwarn ("comma at end of enumerator list"); }
break;
case 277:
#line 1521 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 278:
#line 1523 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-1].ttype, yyvsp[0].ttype);
		  pedwarn ("no semicolon at end of struct or union"); }
break;
case 279:
#line 1528 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 280:
#line 1530 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, yyvsp[-1].ttype); }
break;
case 281:
#line 1532 "c-parse.y"
{ if (pedantic)
		    pedwarn ("extra semicolon in struct or union specified"); }
break;
case 282:
#line 1547 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-1].itype); }
break;
case 283:
#line 1553 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids member declarations with no members");
		  shadow_tag(yyvsp[0].ttype);
		  yyval.ttype = NULL_TREE; }
break;
case 284:
#line 1558 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-1].itype); }
break;
case 285:
#line 1564 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids member declarations with no members");
		  shadow_tag(yyvsp[0].ttype);
		  yyval.ttype = NULL_TREE; }
break;
case 286:
#line 1569 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 287:
#line 1571 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  pedantic = yyvsp[-1].itype; }
break;
case 289:
#line 1578 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 290:
#line 1583 "c-parse.y"
{ yyval.ttype = grokfield (yyvsp[-3].filename, yyvsp[-2].lineno, yyvsp[-1].ttype, current_declspecs, NULL_TREE);
		  decl_attributes (yyval.ttype, yyvsp[0].ttype, prefix_attributes); }
break;
case 291:
#line 1587 "c-parse.y"
{ yyval.ttype = grokfield (yyvsp[-5].filename, yyvsp[-4].lineno, yyvsp[-3].ttype, current_declspecs, yyvsp[-1].ttype);
		  decl_attributes (yyval.ttype, yyvsp[0].ttype, prefix_attributes); }
break;
case 292:
#line 1590 "c-parse.y"
{ yyval.ttype = grokfield (yyvsp[-4].filename, yyvsp[-3].lineno, NULL_TREE, current_declspecs, yyvsp[-1].ttype);
		  decl_attributes (yyval.ttype, yyvsp[0].ttype, prefix_attributes); }
break;
case 294:
#line 1602 "c-parse.y"
{ if (yyvsp[-2].ttype == error_mark_node)
		    yyval.ttype = yyvsp[-2].ttype;
		  else
		    yyval.ttype = chainon (yyvsp[0].ttype, yyvsp[-2].ttype); }
break;
case 295:
#line 1607 "c-parse.y"
{ yyval.ttype = error_mark_node; }
break;
case 296:
#line 1613 "c-parse.y"
{ yyval.ttype = build_enumerator (yyvsp[0].ttype, NULL_TREE); }
break;
case 297:
#line 1615 "c-parse.y"
{ yyval.ttype = build_enumerator (yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 298:
#line 1620 "c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 299:
#line 1622 "c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 300:
#line 1627 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 303:
#line 1634 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 304:
#line 1639 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 305:
#line 1641 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 306:
#line 1646 "c-parse.y"
{ yyval.ttype = yyvsp[-1].ttype; }
break;
case 307:
#line 1649 "c-parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 308:
#line 1651 "c-parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[0].ttype, NULL_TREE); }
break;
case 309:
#line 1653 "c-parse.y"
{ yyval.ttype = build_nt (CALL_EXPR, yyvsp[-2].ttype, yyvsp[0].ttype, NULL_TREE); }
break;
case 310:
#line 1655 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 311:
#line 1657 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-2].ttype, NULL_TREE); }
break;
case 312:
#line 1659 "c-parse.y"
{ yyval.ttype = build_nt (CALL_EXPR, NULL_TREE, yyvsp[0].ttype, NULL_TREE); }
break;
case 313:
#line 1661 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, NULL_TREE, yyvsp[-1].ttype); }
break;
case 314:
#line 1663 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, NULL_TREE, NULL_TREE); }
break;
case 315:
#line 1667 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 316:
#line 1676 "c-parse.y"
{
		  if (pedantic && yyvsp[0].ends_in_label)
		    pedwarn ("ANSI C forbids label at end of compound statement");
		}
break;
case 318:
#line 1685 "c-parse.y"
{ yyval.ends_in_label = yyvsp[0].ends_in_label; }
break;
case 319:
#line 1687 "c-parse.y"
{ yyval.ends_in_label = 0; }
break;
case 321:
#line 1700 "c-parse.y"
{ emit_line_note (input_filename, lineno);
		  pushlevel (0);
		  clear_last_expr ();
		  push_momentary ();
		  UPC_statement_pragma_ok = 0;
		  expand_start_bindings (0);
		}
break;
case 323:
#line 1714 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids label declarations"); }
break;
case 326:
#line 1725 "c-parse.y"
{ tree link;
		  for (link = yyvsp[-1].ttype; link; link = TREE_CHAIN (link))
		    {
		      tree label = shadow_label (TREE_VALUE (link));
		      C_DECLARED_LABEL_FLAG (label) = 1;
		      declare_nonlocal_label (label);
		    }
		}
break;
case 327:
#line 1739 "c-parse.y"
{}
break;
case 329:
#line 1743 "c-parse.y"
{ 
	  push_consistency_nesting_level (1);
	  UPC_statement_pragma_ok = 1;
	  compstmt_count++; }
break;
case 330:
#line 1749 "c-parse.y"
{ yyval.ttype = convert (void_type_node, integer_zero_node);
		pop_consistency_nesting_level (1);	}
break;
case 331:
#line 1753 "c-parse.y"
{ emit_line_note (input_filename, lineno);
		  expand_end_bindings (getdecls (), kept_level_p (), 0);
		  yyval.ttype = poplevel (kept_level_p (), 0, 0);
		  if (yychar == CONSTANT || yychar == STRING)
		    pop_momentary_nofree ();
		  else
		    pop_momentary ();
		  pop_consistency_nesting_level (1); }
break;
case 332:
#line 1762 "c-parse.y"
{ emit_line_note (input_filename, lineno);
		  expand_end_bindings (getdecls (), kept_level_p (), 0);
		  yyval.ttype = poplevel (kept_level_p (), 0, 0);
		  if (yychar == CONSTANT || yychar == STRING)
		    pop_momentary_nofree ();
		  else
		    pop_momentary (); 
		  pop_consistency_nesting_level (1);	}
break;
case 335:
#line 1783 "c-parse.y"
{ emit_line_note (yyvsp[-5].filename, yyvsp[-4].lineno);
		  c_expand_start_cond (truthvalue_conversion (yyvsp[-1].ttype), 0, 
				       compstmt_count);
		  yyval.itype = stmt_count;
		  if_stmt_file = yyvsp[-5].filename;
		  if_stmt_line = yyvsp[-4].lineno;
		  position_after_white_space (); }
break;
case 336:
#line 1797 "c-parse.y"
{ stmt_count++;
		  compstmt_count++;
		  emit_line_note (yyvsp[-2].filename, yyvsp[-1].lineno);
		  /* See comment in `while' alternative, above.  */
		  emit_nop ();
		  expand_start_loop_continue_elsewhere (1);
		  position_after_white_space (); }
break;
case 337:
#line 1805 "c-parse.y"
{ expand_loop_continue_here (); }
break;
case 338:
#line 1809 "c-parse.y"
{ yyval.filename = input_filename; }
break;
case 339:
#line 1813 "c-parse.y"
{ yyval.lineno = lineno; }
break;
case 340:
#line 1818 "c-parse.y"
{ }
break;
case 341:
#line 1823 "c-parse.y"
{ }
break;
case 342:
#line 1828 "c-parse.y"
{ yyval.ends_in_label = yyvsp[0].ends_in_label; }
break;
case 343:
#line 1833 "c-parse.y"
{ yyval.ends_in_label = 0; }
break;
case 344:
#line 1835 "c-parse.y"
{ yyval.ends_in_label = 1; }
break;
case 345:
#line 1837 "c-parse.y"
{ yyval.ends_in_label = 0; }
break;
case 346:
#line 1844 "c-parse.y"
{ stmt_count++; }
break;
case 348:
#line 1847 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
/* It appears that this should not be done--that a non-lvalue array
   shouldn't get an error if the value isn't used.
   Section 3.2.2.1 says that an array lvalue gets converted to a pointer
   if it appears as a top-level expression,
   but says nothing about non-lvalue arrays.  */
#if 0
		  /* Call default_conversion to get an error
		     on referring to a register array if pedantic.  */
		  if (TREE_CODE (TREE_TYPE (yyvsp[-1].ttype)) == ARRAY_TYPE
		      || TREE_CODE (TREE_TYPE (yyvsp[-1].ttype)) == FUNCTION_TYPE)
		    yyvsp[-1].ttype = default_conversion (yyvsp[-1].ttype);
#endif
		  iterator_expand (yyvsp[-1].ttype);
		  clear_momentary (); }
break;
case 349:
#line 1864 "c-parse.y"
{ c_expand_start_else ();
		  yyvsp[-1].itype = stmt_count;
		  position_after_white_space (); }
break;
case 350:
#line 1868 "c-parse.y"
{ c_expand_end_cond ();
		  if (extra_warnings && stmt_count == yyvsp[-3].itype)
		    warning ("empty body in an else-statement"); }
break;
case 351:
#line 1872 "c-parse.y"
{ c_expand_end_cond ();
		  /* This warning is here instead of in simple_if, because we
		     do not want a warning if an empty if is followed by an
		     else statement.  Increment stmt_count so we don't
		     give a second error if this is a nested `if'.  */
		  if (extra_warnings && stmt_count++ == yyvsp[0].itype)
		    warning_with_file_and_line (if_stmt_file, if_stmt_line,
						"empty body in an if-statement"); }
break;
case 352:
#line 1884 "c-parse.y"
{ c_expand_end_cond (); }
break;
case 353:
#line 1886 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-2].filename, yyvsp[-1].lineno);
		  /* The emit_nop used to come before emit_line_note,
		     but that made the nop seem like part of the preceding line.
		     And that was confusing when the preceding line was
		     inside of an if statement and was not really executed.
		     I think it ought to work to put the nop after the line number.
		     We will see.  --rms, July 15, 1991.  */
		  emit_nop (); }
break;
case 354:
#line 1896 "c-parse.y"
{ /* Don't start the loop till we have succeeded
		     in parsing the end test.  This is to make sure
		     that we end every loop we start.  */
		  expand_start_loop (1);
		  emit_line_note (input_filename, lineno);
		  expand_exit_loop_if_false (NULL_PTR,
					     truthvalue_conversion (yyvsp[-1].ttype));
		  position_after_white_space (); }
break;
case 355:
#line 1905 "c-parse.y"
{ expand_end_loop (); }
break;
case 356:
#line 1908 "c-parse.y"
{ emit_line_note (input_filename, lineno);
		  expand_exit_loop_if_false (NULL_PTR,
					     truthvalue_conversion (yyvsp[-2].ttype));
		  expand_end_loop ();
		  clear_momentary (); }
break;
case 357:
#line 1915 "c-parse.y"
{ expand_end_loop ();
		  clear_momentary (); }
break;
case 358:
#line 1917 "c-parse.y"
{ stmt_count++;
		  WFE_Pop_Pragma(); /* see comments in wfe_dst.cxx*/
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  /* See comment in `while' alternative, above.  */
		  emit_nop ();
		  if (yyvsp[0].ttype && yyvsp[0].ttype != c99_for_node)
		    c_expand_expr_stmt (yyvsp[0].ttype);
		  WFE_Push_Pragma();

		  /* Next step is to call expand_start_loop_continue_elsewhere,
		     but wait till after we parse the entire for (...).
		     Otherwise, invalid input might cause us to call that
		     fn without calling expand_end_loop.  */
		}
break;
case 359:
#line 1933 "c-parse.y"
{
		  yyvsp[0].lineno = lineno;
		  yyval.filename = input_filename; 
		}
break;
case 360:
#line 1938 "c-parse.y"
{ 
		  /* Start the loop.  Doing this after parsing
		     all the expressions ensures we will end the loop.  */
		  expand_start_loop_continue_elsewhere (1);
		  /* Emit the end-test, with a line number.  */
		  /* emit_line_note ($<filename>8, $<lineno>7); */
		  emit_line_note (yyvsp[-2].filename, yyvsp[-3].lineno);
		  if (yyvsp[-4].ttype) 
		    expand_exit_loop_if_false (NULL_PTR,
					       truthvalue_conversion (yyvsp[-4].ttype)); 
					       
		  /* Don't let the tree nodes for $9 be discarded by
		     clear_momentary during the parsing of the next stmt.  */
		  push_momentary ();
		  yyvsp[-3].lineno = lineno;
		  yyvsp[-2].filename = input_filename;
		  position_after_white_space (); }
break;
case 361:
#line 1956 "c-parse.y"
{ /* Emit the increment expression, with a line number.  */
		  emit_line_note (yyvsp[-4].filename, yyvsp[-5].lineno);
		  expand_loop_continue_here ();
		   if (yyvsp[-3].ttype) 
 		    c_expand_expr_stmt (yyvsp[-3].ttype); 
		 
		  if (yychar == CONSTANT || yychar == STRING)
		    pop_momentary_nofree ();
		  else
		    pop_momentary ();
		  if (yyvsp[-8].ttype == c99_for_node)
		    poplevel(1,0,0);
		  expand_end_loop ();
		  if (yyvsp[-8].ttype == c99_for_node)
		    WFE_Finish_Inner_Scope();
		}
break;
case 362:
#line 1974 "c-parse.y"
{ stmt_count++;
		  WFE_Pop_Pragma();
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  /* See comment in `while' alternative, above.  */
		  emit_nop ();
		  if (yyvsp[0].ttype && yyvsp[0].ttype != c99_for_node)
		    c_expand_expr_stmt (yyvsp[0].ttype);
		  WFE_Push_Pragma();
		  /* Next step is to call expand_start_loop_continue_elsewhere,
		     but wait till after we parse the entire for (...).
		     Otherwise, invalid input might cause us to call that
		     fn without calling expand_end_loop.  */
		}
break;
case 363:
#line 1989 "c-parse.y"
{ yyvsp[0].lineno = lineno;
		  yyval.filename = input_filename; }
break;
case 364:
#line 1992 "c-parse.y"
{ 
		/* Can't emit now; wait till after expand_start_loop...  */
		  /* $<lineno>10 = lineno; */
		  yyvsp[0].lineno = lineno;
		  yyval.filename = input_filename; }
break;
case 365:
#line 1998 "c-parse.y"
{
		  /* The xexpr of $11 is the affinity expression that
		     determines which thread executes a given iteration
		     of the FORALL loop.  It can evaluate either to a
		     shared address with a thread component or to an
		     integer in the range 0-(THREADS-1), inclusive.  The
		     thread component or the integer will specify the
		     executing thread. */
		  /* In the current implementation the FORALL loop body
		     will be wrapped inside a runtime conditional.  In
		     an unoptimized version, each thread will execute every
		     loop iteration of the loop, deciding on each iteration
		     whether to execute the body or to do the equivalent
		     of "continue" if the affinity is wrong. */
		  /* Start the loop.  Doing this after parsing
		     all the expressions ensures we will end the loop.  */
		  expand_start_loop_continue_elsewhere (1);
		  
		    /* Emit the affinity-test, with a line number.  */
		  emit_line_note (yyvsp[-2].filename, yyvsp[-3].lineno);
		  if (yyvsp[-1].ttype)
		    expand_affinity_test (yyvsp[-1].ttype);

		  /* Emit the end-test, with a line number.  */
		  emit_line_note (yyvsp[-2].filename, yyvsp[-3].lineno);
		  if (yyvsp[-7].ttype)
		    expand_exit_loop_if_false (NULL_PTR,
					       truthvalue_conversion (yyvsp[-7].ttype));
		
		  /* Don't let the tree nodes for $9 be discarded by
		     clear_momentary during the parsing of the next stmt.  */
		  push_momentary ();
		  yyvsp[-3].lineno = lineno;
		  yyvsp[-2].filename = input_filename;
		  position_after_white_space (); }
break;
case 366:
#line 2034 "c-parse.y"
{ /* Emit the increment expression, with a line number.  */
		  emit_line_note (yyvsp[-4].filename, yyvsp[-5].lineno);
		  expand_loop_continue_here ();
		  if (yyvsp[-6].ttype)
		    c_expand_expr_stmt (yyvsp[-6].ttype);
		  if (yychar == CONSTANT || yychar == STRING)
		    pop_momentary_nofree ();
		  else
		    pop_momentary ();
		  if (yyvsp[-11].ttype == c99_for_node)
		    poplevel(1,0,0);
		  expand_end_loop ();
		  if (yyvsp[-11].ttype == c99_for_node)
		    WFE_Finish_Inner_Scope();
		}
break;
case 367:
#line 2050 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-5].filename, yyvsp[-4].lineno);
		  c_expand_start_case (yyvsp[-1].ttype);
		  /* Don't let the tree nodes for $3 be discarded by
		     clear_momentary during the parsing of the next stmt.  */
		  push_momentary ();
		  position_after_white_space (); }
break;
case 368:
#line 2058 "c-parse.y"
{ expand_end_case (yyvsp[-3].ttype);
		  if (yychar == CONSTANT || yychar == STRING)
		    pop_momentary_nofree ();
		  else
		    pop_momentary (); }
break;
case 369:
#line 2064 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  if ( ! expand_exit_something ())
		    error ("break statement not within loop or switch"); }
break;
case 370:
#line 2069 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  if (! expand_continue_loop (NULL_PTR))
		    error ("continue statement not within a loop"); }
break;
case 371:
#line 2074 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  c_expand_return (NULL_TREE); }
break;
case 372:
#line 2078 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  c_expand_return (yyvsp[-1].ttype); }
break;
case 373:
#line 2082 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  upc_expand_sync (1, NULL_TREE); }
break;
case 374:
#line 2086 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  upc_expand_sync (4, NULL_TREE); }
break;
case 375:
#line 2090 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  upc_expand_sync (1, yyvsp[-1].ttype); }
break;
case 376:
#line 2094 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  upc_expand_sync (2, NULL_TREE); }
break;
case 377:
#line 2098 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  upc_expand_sync (2, yyvsp[-1].ttype); }
break;
case 378:
#line 2102 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  upc_expand_sync (3, NULL_TREE); }
break;
case 379:
#line 2106 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  upc_expand_sync (3, yyvsp[-1].ttype); }
break;
case 380:
#line 2110 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-7].filename, yyvsp[-6].lineno);
		  STRIP_NOPS (yyvsp[-2].ttype);
		  if ((TREE_CODE (yyvsp[-2].ttype) == ADDR_EXPR
		       && TREE_CODE (TREE_OPERAND (yyvsp[-2].ttype, 0)) == STRING_CST)
		      || TREE_CODE (yyvsp[-2].ttype) == STRING_CST)
		    expand_asm (yyvsp[-2].ttype);
		  else
		    error ("argument of `asm' is not a constant string"); }
break;
case 381:
#line 2121 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-9].filename, yyvsp[-8].lineno);
		  c_expand_asm_operands (yyvsp[-4].ttype, yyvsp[-2].ttype, NULL_TREE, NULL_TREE,
					 yyvsp[-6].ttype == ridpointers[(int)RID_VOLATILE],
					 input_filename, lineno); }
break;
case 382:
#line 2128 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-11].filename, yyvsp[-10].lineno);
		  c_expand_asm_operands (yyvsp[-6].ttype, yyvsp[-4].ttype, yyvsp[-2].ttype, NULL_TREE,
					 yyvsp[-8].ttype == ridpointers[(int)RID_VOLATILE],
					 input_filename, lineno); }
break;
case 383:
#line 2136 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-13].filename, yyvsp[-12].lineno);
		  c_expand_asm_operands (yyvsp[-8].ttype, yyvsp[-6].ttype, yyvsp[-4].ttype, yyvsp[-2].ttype,
					 yyvsp[-10].ttype == ridpointers[(int)RID_VOLATILE],
					 input_filename, lineno); }
break;
case 384:
#line 2142 "c-parse.y"
{ tree decl;
		  stmt_count++;
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  decl = lookup_label (yyvsp[-1].ttype);
		  if (decl != 0)
		    {
		      TREE_USED (decl) = 1;
		      expand_goto (decl);
		    }
		}
break;
case 385:
#line 2153 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids `goto *expr;'");
		  stmt_count++;
		  emit_line_note (yyvsp[-5].filename, yyvsp[-4].lineno);
		  expand_computed_goto (convert (ptr_type_node, yyvsp[-1].ttype)); }
break;
case 387:
#line 2162 "c-parse.y"
{
	  pushlevel (0);  /* Add a new level for the declarations in a for loop header */
	  WFE_Start_Inner_Scope();
	}
break;
case 388:
#line 2170 "c-parse.y"
{ yyval.ttype = yyvsp[-1].ttype;}
break;
case 389:
#line 2172 "c-parse.y"
{ 
	      check_for_loop_decls(); 
	      yyval.ttype = c99_for_node;
	    }
break;
case 391:
#line 2181 "c-parse.y"
{yyval.ttype = NULL_TREE;}
break;
case 393:
#line 2191 "c-parse.y"
{
	    /* The value returned by this action is  */
	    /*      1 if everything is OK */ 
	    /*      0 in case of error or already bound iterator */

	    yyval.itype = 0;
	    if (TREE_CODE (yyvsp[-1].ttype) != VAR_DECL)
	      error ("invalid `for (ITERATOR)' syntax");
	    else if (! ITERATOR_P (yyvsp[-1].ttype))
	      error ("`%s' is not an iterator",
		     IDENTIFIER_POINTER (DECL_NAME (yyvsp[-1].ttype)));
	    else if (ITERATOR_BOUND_P (yyvsp[-1].ttype))
	      error ("`for (%s)' inside expansion of same iterator",
		     IDENTIFIER_POINTER (DECL_NAME (yyvsp[-1].ttype)));
	    else
	      {
		yyval.itype = 1;
		iterator_for_loop_start (yyvsp[-1].ttype);
	      }
	  }
break;
case 394:
#line 2212 "c-parse.y"
{
	    if (yyvsp[-1].itype)
	      iterator_for_loop_end (yyvsp[-3].ttype);
	  }
break;
case 395:
#line 2247 "c-parse.y"
{ register tree value = check_case_value (yyvsp[-1].ttype);
		  register tree label
		    = build_decl (LABEL_DECL, NULL_TREE, NULL_TREE);

		  stmt_count++;

		  if (value != error_mark_node)
		    {
		      tree duplicate;
		      int success;

		      if (pedantic && ! INTEGRAL_TYPE_P (TREE_TYPE (value)))
			pedwarn ("label must have integral type in ANSI C");

		      success = pushcase (value, convert_and_check,
					  label, &duplicate);

		      if (success == 1)
			error ("case label not within a switch statement");
		      else if (success == 2)
			{
			  error ("duplicate case value");
			  error_with_decl (duplicate, "this is the first entry for that value");
			}
		      else if (success == 3)
			warning ("case value out of range");
		      else if (success == 5)
			error ("case label within scope of cleanup or variable array");
		    }
		  position_after_white_space (); }
break;
case 396:
#line 2278 "c-parse.y"
{ register tree value1 = check_case_value (yyvsp[-3].ttype);
		  register tree value2 = check_case_value (yyvsp[-1].ttype);
		  register tree label
		    = build_decl (LABEL_DECL, NULL_TREE, NULL_TREE);

		  if (pedantic)
		    pedwarn ("ANSI C forbids case ranges");
		  stmt_count++;

		  if (value1 != error_mark_node && value2 != error_mark_node)
		    {
		      tree duplicate;
		      int success = pushcase_range (value1, value2,
						    convert_and_check, label,
						    &duplicate);
		      if (success == 1)
			error ("case label not within a switch statement");
		      else if (success == 2)
			{
			  error ("duplicate case value");
			  error_with_decl (duplicate, "this is the first entry for that value");
			}
		      else if (success == 3)
			warning ("case value out of range");
		      else if (success == 4)
			warning ("empty case range");
		      else if (success == 5)
			error ("case label within scope of cleanup or variable array");
		    }
		  position_after_white_space (); }
break;
case 397:
#line 2309 "c-parse.y"
{
		  tree duplicate;
		  register tree label
		    = build_decl (LABEL_DECL, NULL_TREE, NULL_TREE);
		  int success = pushcase (NULL_TREE, 0, label, &duplicate);
		  stmt_count++;
		  if (success == 1)
		    error ("default label not within a switch statement");
		  else if (success == 2)
		    {
		      error ("multiple default labels in one switch");
		      error_with_decl (duplicate, "this is the first default label");
		    }
		  position_after_white_space (); }
break;
case 398:
#line 2324 "c-parse.y"
{ tree label = define_label (input_filename, lineno, yyvsp[-2].ttype);
		  stmt_count++;
		  emit_nop ();
		  if (label)
		    {
		      expand_label (label);
		      decl_attributes (label, yyvsp[0].ttype, NULL_TREE);
		    }
		  position_after_white_space (); }
break;
case 399:
#line 2339 "c-parse.y"
{ emit_line_note (input_filename, lineno);
		  yyval.ttype = NULL_TREE; }
break;
case 400:
#line 2342 "c-parse.y"
{ emit_line_note (input_filename, lineno); }
break;
case 401:
#line 2347 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 403:
#line 2351 "c-parse.y"
{ yyval.ttype = star_layout_node; }
break;
case 404:
#line 2357 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 407:
#line 2364 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 408:
#line 2369 "c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 409:
#line 2374 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, combine_strings (yyvsp[0].ttype), NULL_TREE); }
break;
case 410:
#line 2376 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, combine_strings (yyvsp[0].ttype), yyvsp[-2].ttype); }
break;
case 411:
#line 2382 "c-parse.y"
{ pushlevel (0);
		  clear_parm_order ();
		  declare_parm_level (0); }
break;
case 412:
#line 2386 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  parmlist_tags_warning ();
		  poplevel (0, 0, 0); }
break;
case 414:
#line 2394 "c-parse.y"
{ tree parm;
		  if (pedantic)
		    pedwarn ("ANSI C forbids forward parameter declarations");
		  /* Mark the forward decls as such.  */
		  for (parm = getdecls (); parm; parm = TREE_CHAIN (parm))
		    TREE_ASM_WRITTEN (parm) = 1;
		  clear_parm_order (); }
break;
case 415:
#line 2402 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 416:
#line 2404 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, NULL_TREE, NULL_TREE); }
break;
case 417:
#line 2410 "c-parse.y"
{ yyval.ttype = get_parm_info (0); }
break;
case 418:
#line 2412 "c-parse.y"
{ yyval.ttype = get_parm_info (0);
		  /* Gcc used to allow this as an extension.  However, it does
		     not work for all targets, and thus has been disabled.
		     Also, since func (...) and func () are indistinguishable,
		     it caused problems with the code in expand_builtin which
		     tries to verify that BUILT_IN_NEXT_ARG is being used
		     correctly.  */
		  error ("ANSI C requires a named argument before `...'");
		}
break;
case 419:
#line 2422 "c-parse.y"
{ yyval.ttype = get_parm_info (1); }
break;
case 420:
#line 2424 "c-parse.y"
{ yyval.ttype = get_parm_info (0); }
break;
case 421:
#line 2429 "c-parse.y"
{ push_parm_decl (yyvsp[0].ttype); }
break;
case 422:
#line 2431 "c-parse.y"
{ push_parm_decl (yyvsp[0].ttype); }
break;
case 423:
#line 2438 "c-parse.y"
{ yyval.ttype = build_tree_list (build_tree_list (current_declspecs,
							 yyvsp[-1].ttype),
					build_tree_list (prefix_attributes,
							 yyvsp[0].ttype));
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 424:
#line 2447 "c-parse.y"
{ yyval.ttype = build_tree_list (build_tree_list (current_declspecs,
							 yyvsp[-1].ttype),
					build_tree_list (prefix_attributes,
							 yyvsp[0].ttype)); 
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 425:
#line 2456 "c-parse.y"
{ yyval.ttype = build_tree_list (build_tree_list (current_declspecs,
							 yyvsp[-1].ttype),
					build_tree_list (prefix_attributes,
							 yyvsp[0].ttype));
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 426:
#line 2465 "c-parse.y"
{ yyval.ttype = build_tree_list (build_tree_list (current_declspecs,
							 yyvsp[-1].ttype),
					build_tree_list (prefix_attributes,
							 yyvsp[0].ttype));
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype);  }
break;
case 427:
#line 2475 "c-parse.y"
{ yyval.ttype = build_tree_list (build_tree_list (current_declspecs,
							 yyvsp[-1].ttype),
					build_tree_list (prefix_attributes,
							 yyvsp[0].ttype));
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype);  }
break;
case 428:
#line 2489 "c-parse.y"
{ pushlevel (0);
		  clear_parm_order ();
		  declare_parm_level (1); }
break;
case 429:
#line 2493 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  parmlist_tags_warning ();
		  poplevel (0, 0, 0); }
break;
case 431:
#line 2501 "c-parse.y"
{ tree t;
		  for (t = yyvsp[-1].ttype; t; t = TREE_CHAIN (t))
		    if (TREE_VALUE (t) == NULL_TREE)
		      error ("`...' in old-style identifier list");
		  yyval.ttype = tree_cons (NULL_TREE, NULL_TREE, yyvsp[-1].ttype); }
break;
case 432:
#line 2511 "c-parse.y"
{ yyval.ttype = build_tree_list (NULL_TREE, yyvsp[0].ttype); }
break;
case 433:
#line 2513 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, build_tree_list (NULL_TREE, yyvsp[0].ttype)); }
break;
case 434:
#line 2519 "c-parse.y"
{ yyval.ttype = build_tree_list (NULL_TREE, yyvsp[0].ttype); }
break;
case 435:
#line 2521 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, build_tree_list (NULL_TREE, yyvsp[0].ttype)); }
break;
case 436:
#line 2526 "c-parse.y"
{ yyval.itype = pedantic;
		  pedantic = 0; }
break;
#line 4646 "c-parse.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
